SystemOrganization addCategory: #'OrbeonPersistenceApi'!

OrbeonException subclass: #AlreadyExistApplicationOrFormNameException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!AlreadyExistApplicationOrFormNameException class methodsFor: 'other' stamp: 'BrunoBB 05/02/2016 13:52'!
installHandler

	self addDefaultHandler: [:ex | ex resume].! !

!AlreadyExistApplicationOrFormNameException methodsFor: 'other' stamp: 'BrunoBB 05/02/2016 09:26'!
defaultAction
	"When this exception happend nothing is done (just resume the execution)"! !

!AlreadyExistApplicationOrFormNameException methodsFor: 'other' stamp: 'BrunoBB 05/01/2016 09:44'!
isResumable

	^true! !

OrbeonException subclass: #DirectoryStructureNotPresentException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

Object subclass: #OrbeonApiConfiguration
	instanceVariableNames: 'isEnabled deferredXmlProcessing bpmForms pathForAttachments baseAttachmentPath searchTypes formsAudit'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonApiConfiguration commentStamp: 'BrunoBB 09/15/2015 14:20' prior: 0!
baseAttachmentPath - includes 5 subdirectories

Save Definitions (not been published yet)
baseAttachmentPath/definitions/saved

Published Definitions 
baseAttachmentPath/definitions/published

Forms Drafts 
baseAttachmentPath/drafts

Forms Instances
baseAttachmentPath/instances

Temporary (used as general repository for saved definitions - issue #37)
baseAttachmentPath/temp!

!OrbeonApiConfiguration class methodsFor: 'other' stamp: 'BrunoBB 09/24/2016 15:25'!
default

	Default ifNil: [Default := super new initialize].

	^Default! !

!OrbeonApiConfiguration class methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 12:57'!
initialize

	super initialize.

	Default := super new initialize! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/03/2015 14:30'!
baseAttachmentPath
	^baseAttachmentPath! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/03/2015 14:30'!
baseAttachmentPath: newValue
	baseAttachmentPath := newValue! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/03/2015 12:51'!
bpmForms
	^bpmForms! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/03/2015 12:51'!
bpmForms: newValue
	bpmForms := newValue! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 08/26/2015 17:48'!
deferredXmlProcessing
	^deferredXmlProcessing! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 08/26/2015 17:48'!
deferredXmlProcessing: newValue
	deferredXmlProcessing := newValue! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:57'!
disableDefinitionAuditFor: formName in: app
	"The receiver disable the audit option for form definition named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) remove: #definitions ifAbsent: []! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:58'!
disableDraftAuditFor: formName in: app
	"The receiver disable the audit option for drafts of form named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) remove: #drafts ifAbsent: []! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:58'!
disableInstanceAuditFor: formName in: app
	"The receiver enable the audit option for form named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) remove: #instances ifAbsent: []! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:57'!
enableDefinitionAuditFor: formName in: app
	"The receiver enable the audit option for form definition named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) add: #definitions! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:56'!
enableDraftAuditFor: formName in: app
	"The receiver enable the audit option for drafts of form named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) add: #drafts! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 09:56'!
enableInstanceAuditFor: formName in: app
	"The receiver enable the audit option for form named <formName> in application <app>"

	^((formsAudit at: app ifAbsentPut: [Dictionary new])
			at: formName ifAbsentPut: [Set new]) add: #instances! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 03/21/2017 14:20'!
existDirectoryStructureForAttachments

	(GsFile existsOnServer: self getTempPath) 
		ifFalse: [DirectoryStructureNotPresentException signal: 'Directory Structure to Store Forms attachments on disk has not been created'].

	^true! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/21/2015 09:44'!
formsAudit
	^formsAudit! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/21/2015 09:44'!
formsAudit: newValue
	formsAudit := newValue! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 14:31'!
getBasePathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"

	^(pathForAttachments at: appName ifAbsent: [^baseAttachmentPath])
		at: formName ifAbsent: [baseAttachmentPath]! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 14:35'!
getDraftsPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'drafts/'! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 14:35'!
getInstancesPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'instances/'! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 14:36'!
getPublishedDefinitionsPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'definitions/published/'! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 14:34'!
getSavedDefinitionsPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'definitions/saved/'! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/08/2015 13:24'!
getTempPath
	"Answer the temp path to store save definitions. See issue #37"

	^baseAttachmentPath, 'temp'! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 09:46'!
initialize

	super initialize.

	baseAttachmentPath := '/opt/orbeon-files/'.
	isEnabled := false.
	"some forms can be processed on demand others later. If <true> is deferred processing if <false> is on demand"
	deferredXmlProcessing := Dictionary new. 
	bpmForms := Dictionary new. "some forms are used in the BPM application others not (only as regular Orbeon Forms) "
	pathForAttachments := Dictionary new. "the path to store attachments of the forms"
	searchTypes := Dictionary new. "the search type of each form when a search has more than one value (#or #and)"
	formsAudit := Dictionary new. "whether or not an app.form has any audit configurations #(#drafs #instances #definitions)"! !

!OrbeonApiConfiguration methodsFor: 'deferred processing' stamp: 'BrunoBB 09/11/2015 14:36'!
isDeferredProcessing: formName in: appName
	"Answer whether of not the form named <formName> in the application <appName> has deferred XML processing
	If value is <true> then the XML processing is deferred"

	^(deferredXmlProcessing at: appName ifAbsent: [^false])
		at: formName ifAbsent: [^false]! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 10:01'!
isDefinitionAuditEnableFor: formName in: app
	"The receiver answer whether of not the audit option is enabled for form definition named <formName> in application <app>"

	^((formsAudit at: app ifAbsent: [^false])
			at: formName ifAbsent: [^false]) includes: #definitions! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 10:00'!
isDraftAuditEnableFor: formName in: app
	"The receiver answer whether of not the audit option is enabled for draft of form named <formName> in application <app>"

	^((formsAudit at: app ifAbsent: [^false])
			at: formName ifAbsent: [^false]) includes: #drafts! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 08/26/2015 17:49'!
isEnabled
	^isEnabled! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 08/26/2015 17:49'!
isEnabled: newValue
	isEnabled := newValue! !

!OrbeonApiConfiguration methodsFor: 'audit' stamp: 'BrunoBB 09/21/2015 10:00'!
isInstanceAuditEnableFor: formName in: app
	"The receiver answer whether of not the audit option is enabled for form named <formName> in application <app>"

	^((formsAudit at: app ifAbsent: [^false])
			at: formName ifAbsent: [^false]) includes: #instances! !

!OrbeonApiConfiguration methodsFor: 'deferred processing' stamp: 'BrunoBB 09/03/2015 13:35'!
isOnDemandProcessing: formName in: appName
	"Answer whether of not the form named <formName> in the application <appName> has on demand XML processing
	If value is <false> then the XML processing is on demand"

	^((deferredXmlProcessing at: appName ifAbsent: [^true])
		at: formName) not! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/03/2015 12:54'!
pathForAttachments
	^pathForAttachments! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/03/2015 12:54'!
pathForAttachments: newValue
	pathForAttachments := newValue! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/15/2015 14:22'!
searchTypes
	^searchTypes! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/15/2015 14:22'!
searchTypes: newValue
	searchTypes := newValue! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/15/2015 15:18'!
setAndTypeSearchFor: formName in: appName
	"The receiver set the type search as AND for the form definition named <formName> in the application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^(searchTypes at: appName ifAbsentPut: [Dictionary new])
		at: formName put: true! !

!OrbeonApiConfiguration methodsFor: 'deferred processing' stamp: 'BrunoBB 09/03/2015 13:36'!
setDeferredProcessingFor: formName in: appName
	"The receiver set the XML processing as -Deferred- for the form named <formName> in the applicacion named <appName> "

	^(deferredXmlProcessing at: appName ifAbsentPut: [Dictionary new])
		at: formName put: true! !

!OrbeonApiConfiguration methodsFor: 'deferred processing' stamp: 'BrunoBB 09/03/2015 13:36'!
setOnDemandProcessingFor: formName in: appName
	"The receiver set the XML processing as -On Demand- for the form named <formName> in the applicacion named <appName> "

	^(deferredXmlProcessing at: appName ifAbsentPut: [Dictionary new])
		at: formName put: false! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/15/2015 15:18'!
setOrTypeSearchFor: formName in: appName
	"The receiver set the type search as OR for the form definition named <formName> in the application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^(searchTypes at: appName ifAbsentPut: [Dictionary new])
		at: formName put: false! !

!OrbeonApiConfiguration methodsFor: 'attachment path' stamp: 'BrunoBB 09/03/2015 13:58'!
setPath: aPath for: formName in: appName
	"The receiver set the path <aPath> to store forms attachment for form named <formName> in the application <appName> "

	^(pathForAttachments at: appName ifAbsentPut: [Dictionary new])
		at: formName put: aPath! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/15/2015 14:22'!
tempAttachmentPath
	^tempAttachmentPath! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/15/2015 14:22'!
tempAttachmentPath: newValue
	tempAttachmentPath := newValue! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/16/2015 10:31'!
typeSearchIsAnd: formName in: appName
	"Answer whether or not the type search is AND for the form definition <formName> in application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^((searchTypes at: appName ifAbsent: [^false])
		at: formName ifAbsent: [^false]) == true! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/16/2015 10:30'!
typeSearchIsOr: formName in: appName
	"Answer whether or not the type search is OR for the form definition <formName> in application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^((searchTypes at: appName ifAbsent: [^true])
		at: formName ifAbsent: [^true]) == false! !

Object subclass: #OrbeonAuditStorage
	instanceVariableNames: 'drafts instances definitions'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonAuditStorage class methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 10:02'!
default

	Default ifNil: [Default := super new initialize].

	^Default! !

!OrbeonAuditStorage class methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 10:02'!
initialize

	super initialize.

	Default := super new initialize! !

!OrbeonAuditStorage methodsFor: 'other' stamp: 'BrunoBB 04/28/2016 10:42'!
addDefinitionAudit: anOrbeonFormInstanceDefinition
	"The receiver add to the audit collection the form definition <anOrbeonFormInstanceDefinition>"

	^((definitions at: anOrbeonFormInstanceDefinition getApplicationName ifAbsentPut: [RcKeyValueDictionary new])
		at: anOrbeonFormInstanceDefinition formName ifAbsentPut: RcIdentityBag new) add: anOrbeonFormInstanceDefinition! !

!OrbeonAuditStorage methodsFor: 'other' stamp: 'BrunoBB 04/28/2016 10:42'!
addDraftAudit: anOrbeonFormInstance
	"The receiver add to the audit collection the form draft <anOrbeonFormInstance>"

	^((drafts at: anOrbeonFormInstance getApplicationName ifAbsentPut: [RcKeyValueDictionary new])
		at: anOrbeonFormInstance formName ifAbsentPut: RcIdentityBag new) add: anOrbeonFormInstance! !

!OrbeonAuditStorage methodsFor: 'other' stamp: 'BrunoBB 04/28/2016 10:43'!
addInstanceAudit: anOrbeonFormInstance
	"The receiver add to the audit collection the form instance <anOrbeonFormInstance>"

	^((instances at: anOrbeonFormInstance getApplicationName ifAbsentPut: [RcKeyValueDictionary new])
		at: anOrbeonFormInstance formName ifAbsentPut: RcIdentityBag new) add: anOrbeonFormInstance! !

!OrbeonAuditStorage methodsFor: 'Accessing' stamp: 'BrunoBB 09/21/2015 10:02'!
definitions
	^definitions! !

!OrbeonAuditStorage methodsFor: 'Updating' stamp: 'BrunoBB 09/21/2015 10:02'!
definitions: newValue
	definitions := newValue! !

!OrbeonAuditStorage methodsFor: 'Accessing' stamp: 'BrunoBB 09/21/2015 10:02'!
drafts
	^drafts! !

!OrbeonAuditStorage methodsFor: 'Updating' stamp: 'BrunoBB 09/21/2015 10:02'!
drafts: newValue
	drafts := newValue! !

!OrbeonAuditStorage methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 10:02'!
initialize

	super initialize.

	definitions := RcKeyValueDictionary new.
	drafts := RcKeyValueDictionary new.
	instances := RcKeyValueDictionary new.! !

!OrbeonAuditStorage methodsFor: 'Accessing' stamp: 'BrunoBB 09/21/2015 10:02'!
instances
	^instances! !

!OrbeonAuditStorage methodsFor: 'Updating' stamp: 'BrunoBB 09/21/2015 10:02'!
instances: newValue
	instances := newValue! !

Object subclass: #OrbeonDeferredProcessingQueue
	instanceVariableNames: 'instances'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonDeferredProcessingQueue class methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 14:57'!
default

	Default ifNil: [Default := super new initialize].

	^Default! !

!OrbeonDeferredProcessingQueue class methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 14:57'!
initialize

	super initialize.

	Default := super new initialize! !

!OrbeonDeferredProcessingQueue methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 14:39'!
addDeferredInstance: anOrbeonFormInstance

	^instances add: anOrbeonFormInstance! !

!OrbeonDeferredProcessingQueue methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 15:07'!
initialize

	super initialize.

	instances := RcIdentityBag new.! !

!OrbeonDeferredProcessingQueue methodsFor: 'Accessing' stamp: 'BrunoBB 09/01/2015 12:33'!
instances
	^instances! !

!OrbeonDeferredProcessingQueue methodsFor: 'Updating' stamp: 'BrunoBB 09/01/2015 12:33'!
instances: newValue
	instances := newValue! !

!OrbeonDeferredProcessingQueue methodsFor: 'other' stamp: 'BrunoBB 09/13/2015 12:43'!
processInstances
	"The receiver process the unprocessed instances <OrbeonFormInstance>.	
	The instance variable <instances> is modified by various concurrent gem process"
	| processedInstances |
	
	processedInstances  := OrderedCollection new.
	instances do: [:each | 
		each processXML.
		processedInstances add: each].

	processedInstances do: [:each | instances remove: each ifAbsent: []]! !

Object subclass: #OrbeonMaintenanceScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 05/04/2016 14:52'!
deleteUnusedFormInstanceOSFiles
	"The receiver delete all unused files of Form Instances from OS file system"

	self deleteUnusedOSFiles: self getInstancesUsedAttachmentIDs pathSelector: #getInstancesPathFor:in:! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/06/2015 13:09'!
deleteUnusedOSFiles: usedDictionaryIds pathSelector: pathSelector
	"Delete unused OS files from calculated <pathSelector> that are no included in the dictionary <usedDictionaryIds>.
	<usedDictionaryIds> key is (app.formName) and value is a collection of ids."

	usedDictionaryIds keysAndValuesDo: [:appForm :collectionId | | path app form currentFiles |
		app := (appForm subStrings: '.') first.
		form := (appForm subStrings: '.') second.
		path := OrbeonApiConfiguration default perform: pathSelector with: form with: app."get tha path for <app> and <form>"
		currentFiles := ((GsFile contentsOfDirectory: path onClient: false) "get all current files in <path>"
			reject: [:eachPathFile | ((eachPathFile subStrings: '/') last = '.') or: [(eachPathFile subStrings: '/') last = '..']])
			collect: [:each | (each subStrings: '/') last].
		"remove files from <path> that are not included in <collectionId> block argument"
		currentFiles do: [:eachPathFile | (collectionId includes: eachPathFile) ifFalse: [GsFile removeServerFile: path, eachPathFile]].
	]! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 05/04/2016 14:53'!
deleteUnusedPublishedFormsOSFiles
	"The receiver delete all unused files of Form Definitions from OS file system"

	self deleteUnusedOSFiles: self getDefinitionUsedAttachmentIDs pathSelector: #getPublishedDefinitionsPathFor:in:! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 05/04/2016 14:52'!
deleteUnusedSavedFormsOSFiles
	"The receiver delete all unused files of Form Instance Definitions from OS file system"

	self deleteUnusedOSFiles: self getDefinitionUsedAttachmentIDs pathSelector: #getSavedDefinitionsPathFor:in:! !

!OrbeonMaintenanceScript class methodsFor: 'query attachments' stamp: 'BrunoBB 05/06/2016 13:25'!
getDefinitionUsedAttachmentIDs
	"Answer a dictionary of all used attachment's ids. Where the key is <app.formName> and the value is the actual collection"
	| allAttachmentIds |

	allAttachmentIds := Dictionary new.

	self getOrbeonApplicationCache do: [:eachApp | 
		eachApp definitionRegistry keysAndValuesDo: [:formName :registry |

			registry currentVersions do: [:eachDef | 
				allAttachmentIds at: (eachApp applicationName, '.', eachDef formName) 
					ifAbsent: [allAttachmentIds at: (eachApp applicationName, '.', eachDef formName) 
															put: (OrderedCollection withAll: eachDef attachments)]
					ifPresent: [:collection | collection addAll: eachDef attachments].
			].
			registry oldVersions do: [:eachDef | 
				allAttachmentIds at: (eachApp applicationName, '.', eachDef formName) 
					ifAbsent: [allAttachmentIds at: (eachApp applicationName, '.', eachDef formName) 
															put: (OrderedCollection withAll: eachDef attachments)]
					ifPresent: [:collection | collection addAll: eachDef attachments].
			].
		].
	].

	^allAttachmentIds! !

!OrbeonMaintenanceScript class methodsFor: 'query attachments' stamp: 'BrunoBB 05/06/2016 13:25'!
getInstanceDefinitionUsedAttachmentIDs
	"Answer a dictionary of all used attachment's ids. Where the key is <app.formName> and the value is the actual collection"
	| allAttachmentIds |

	allAttachmentIds := Dictionary new.

	self getOrbeonApplicationCache do: [:eachApp | 
		eachApp definitionRegistry keysAndValuesDo: [:formName :registry |

			registry savedDefinitions do: [:eachInstDef | 
				allAttachmentIds at: (eachInstDef getApplicationName, '.', eachInstDef formName) 
					ifAbsent: [allAttachmentIds at: (eachApp applicationName, '.', eachInstDef formName) 
															put: (OrderedCollection withAll: eachInstDef attachments)]
					ifPresent: [:collection | collection addAll: eachInstDef attachments].
			].
		].
	].

	^allAttachmentIds! !

!OrbeonMaintenanceScript class methodsFor: 'query attachments' stamp: 'BrunoBB 05/06/2016 13:26'!
getInstancesUsedAttachmentIDs
	"Answer a dictionary of all used attachment's ids. Where the key is <app.formName> and the value is the actual collection"
	| allAttachmentIds |

	allAttachmentIds := Dictionary new.

	self getOrbeonApplicationCache do: [:eachApp | 
		eachApp definitionRegistry keysAndValuesDo: [:formName :registry |

			registry currentVersions do: [:eachDef | 
				eachDef instances do: [:eachInst | 
					allAttachmentIds at: (eachApp applicationName, '.', eachDef formName)
						ifAbsent: [allAttachmentIds at: (eachApp applicationName, '.', eachDef formName) 
																put: (OrderedCollection withAll: eachInst getAttachmentIds)]
						ifPresent: [:collection | collection addAll: eachInst getAttachmentIds]].
			].
			registry oldVersions do: [:eachDef | 
				eachDef instances do: [:eachInst | 
					allAttachmentIds at: (eachApp applicationName, '.', eachDef formName)
						ifAbsent: [allAttachmentIds at: (eachApp applicationName, '.', eachDef formName) 
																put: (OrderedCollection withAll: eachInst getAttachmentIds)]
						ifPresent: [:collection | collection addAll: eachInst getAttachmentIds]].
			].
		].
	].

	^allAttachmentIds! !

!OrbeonMaintenanceScript class methodsFor: 'forms' stamp: 'BrunoBB 02/08/2016 11:29'!
physicallyRemoveFormInstances
	"WARNING AFTER EXECUTING THIS METHOD THE OBJECTS ARE NOT RECOVERABLE ANY MORE"
	"This is a Time and Resource consuming Operation"
	"Remove all FormInstances where <deleted> is 'Y' "

	(self getOrbeonApplicationClass getAllInstances select: [:each | each deleted = 'Y']) do: [:each | 
		each definition removeInstance: each]! !

!OrbeonMaintenanceScript class methodsFor: 'forms' stamp: 'BrunoBB 05/04/2016 14:54'!
physicallyRemovePublishedForms
	"WARNING AFTER EXECUTING THIS METHOD THE OBJECTS ARE NOT RECOVERABLE ANY MORE"
	"This is a Time and Resource consuming Operation"
	"Remove all FormDefinitions where <deleted> is 'Y' "

	(self getOrbeonApplicationClass getAllFormDefinitions select: [:each | each deleted = 'Y']) do: [:each | 
		each getApplication removeDefinition: each]! !

!OrbeonMaintenanceScript class methodsFor: 'forms' stamp: 'BrunoBB 05/04/2016 14:55'!
physicallyRemoveSavedForms
	"WARNING AFTER EXECUTING THIS METHOD THE OBJECTS ARE NOT RECOVERABLE ANY MORE"
	"This is a Time and Resource consuming Operation"
	"Remove all FormInstanceDefinitions where <deleted> is 'Y' "

	(self getOrbeonApplicationClass getAllSavedDefinitions select: [:each | each deleted = 'Y']) do: [:each | 
		each getApplication removeInstanceDefinition: each]! !

Object subclass: #OrbeonQueryNode
	instanceVariableNames: 'name path type control searchField summaryField match value isGeneric'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

OrbeonQueryNode class
	instanceVariableNames: 'cache'!

!OrbeonQueryNode methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 12:45'!
beGeneric

	isGeneric := true! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
control
	^control! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
control: newValue
	control := newValue! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 12:18'!
hasValue

	^value notNil! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 12:21'!
hasValueAndNoName

	^name isEmpty and: [value notNil]! !

!OrbeonQueryNode methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 12:44'!
initialize

	super initialize.

	isGeneric := false.! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 12:44'!
isGeneric
	^isGeneric! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 12:44'!
isGeneric: newValue
	isGeneric := newValue! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 12:11'!
isSearchAndHasValue

	^(searchField = 'true') and: [value notNil]! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 12:33'!
isSummary

	^summaryField = 'true'! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
match
	^match! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
match: newValue
	match := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
name
	^name! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
name: newValue
	name := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
path
	^path! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
path: newValue
	path := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
searchField
	^searchField! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
searchField: newValue
	searchField := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
summaryField
	^summaryField! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
summaryField: newValue
	summaryField := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
type
	^type! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
type: newValue
	type := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
value
	^value! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
value: newValue
	value := newValue! !

Object subclass: #OrbeonServiceOperationApi
	instanceVariableNames: 'restHandler xmlString id version xmlDocument formReader appName formName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

OrbeonServiceOperationApi subclass: #OrbeonFileOperationApi
	instanceVariableNames: 'fileId fileContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFileOperationApi methodsFor: 'Accessing' stamp: 'brunobb 02/17/2018 08:00'!
fileContents
	^fileContents! !

!OrbeonFileOperationApi methodsFor: 'Updating' stamp: 'brunobb 02/17/2018 08:00'!
fileContents: newValue
	fileContents := newValue! !

!OrbeonFileOperationApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 11:52'!
fileId
	^fileId! !

!OrbeonFileOperationApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 11:52'!
fileId: newValue
	fileId := newValue! !

OrbeonFileOperationApi subclass: #OrbeonFileReceiveApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

OrbeonFileReceiveApi subclass: #OrbeonReceiveAndPublishFileApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonReceiveAndPublishFileApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 08:03'!
doIt
	"This service is called when a user click -Publish- form in Orbeon Form Builder and the form definition has attached files.
	The Form Definition is <formName> in the Orbeon Application <app> where the id of the form definition is <id> and the attached file id is <fileId>.
	This service is called for each attached files in the Form Definition. 
	The attached file is stored in the repository"
	| gsFile path |

	path := self apiConfiguration getPublishedDefinitionsPathFor: self getFormName in: self getApplicationName.

	(GsFile existsOnServer: path) ifFalse: [DirectoryStructureNotPresentException signal: 'Directory Structure to Store Forms attachments on disk has not been created'].

	gsFile := GsFile open: (path, id, '-',fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: fileContents;
		flush;
		close.! !

OrbeonFileReceiveApi subclass: #OrbeonReceiveAndSaveDefinitionFileApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonReceiveAndSaveDefinitionFileApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 08:33'!
doIt
	"This service receives a file with id <fileId> from Orbeon Form Builder when the a user clicked -Save-.
	The file was uploaded into a Form Definition as a Custom PDF or as direct file Upload.
	A direct file upload is when a File Attachment is added to a Form Definition and a concrete file is also uploaded"
	| definition gsFile |

	definition := self getOrbeonApplicationClass getAnyDefinitionWithId: id ifNone: [^self storeFileOnTempPath].

	gsFile := GsFile open: ((self apiConfiguration getSavedDefinitionsPathFor: definition formName in: definition getApplicationName), id, '-', fileId, '.bin') mode: 'wb' onClient: false.

	gsFile
		nextPutAll: fileContents;
		flush;
		close.! !

!OrbeonReceiveAndSaveDefinitionFileApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 08:32'!
storeFileOnTempPath
	"The receiver store the file with id <fileId> belonging to the form definition with id <definitionId> in the temporary path.
	This method is called when a Form Definition has attachments and is save at once with the attachments.
	In this case the OrbeonFormDefinition has not been created and we can not get the current path to store files so we store them in the temp path.
	See issue #37 and is caused because Orbeon first call a service to store attachments and then call a service to store XML definition"
	| gsFile |

	gsFile := GsFile open: (self apiConfiguration getTempPath,'/', id, '-', fileId, '.bin') mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

OrbeonFileReceiveApi subclass: #OrbeonReceiveAndSaveDraftFileApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonReceiveAndSaveDraftFileApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 08:40'!
doIt
	"This service is called from Orbeon Form Runner -new/edit- when a file is uploaded (and autosave is -true-) to a Form Instance.
	When the form is autosaved then all form's attachments are sent to this service "
	| gsFile |

	gsFile := GsFile open: ((self apiConfiguration getDraftsPathFor: self getFormName in: self getApplicationName), id, '-', fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: fileContents;
		flush;
		close.! !

OrbeonFileReceiveApi subclass: #OrbeonReceiveAndSaveInstanceFileApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonReceiveAndSaveInstanceFileApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 08:46'!
doIt
	"This service is called from Orbeon Form Runner -new/edit- when a file is uploaded (and autosave is -true-) to a Form Instance.
	When the form is autosaved then all form's attachments are sent to this service "
	| gsFile |

	gsFile := GsFile open: ((self apiConfiguration getInstancesPathFor: self getFormName in: self getApplicationName), id, '-', fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: fileContents;
		flush;
		close.! !

OrbeonFileOperationApi subclass: #OrbeonFileSendApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

OrbeonFileSendApi subclass: #OrbeonSendCustomPdfFileApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonSendCustomPdfFileApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 09:52'!
doIt
	"This service is called when Orbeon requires a Custom PDF of a form or the Form Instance has any attachments and the user has clicked -Send-"
	| definition gsFile |

	restHandler requestContext response contentType: WAMimeType applicationOctetStream.

	definition := self getOrbeonApplicationClass formDefinitionNamed: self getFormName in: self getApplicationName.

	gsFile := GsFile openOnServer: ((self apiConfiguration getPublishedDefinitionsPathFor: self getFormName in: self getApplicationName), definition id, '-', fileId) mode: 'rb'.
	fileContents := gsFile contentsAsUtf8.

	gsFile close.

	^fileContents! !

OrbeonFileSendApi subclass: #OrbeonSendFormDefinitionFileApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonSendFormDefinitionFileApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 09:38'!
doIt
	"This service is called by Orbeon Form Builder to get/obtain the attached file with id <fileId> for the Form Definition <id>.
	The service answer an octet stream to the caller."
	| definition gsFile |

	definition := self getOrbeonApplicationClass getAnyDefinitionWithId: id ifNone: [^NoOrbeonFormException signal: 'No form definition with id [', id, ']'].

	restHandler requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ((self apiConfiguration getSavedDefinitionsPathFor: definition formName in: definition getApplicationName), id, '-',fileId) mode: 'rb'.
	fileContents := gsFile contentsAsUtf8.

	gsFile close.

	^fileContents! !

OrbeonFileSendApi subclass: #OrbeonSendFormDraftFileApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonSendFormDraftFileApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 09:42'!
doIt
	"This service is called when rendering the Draft of the form in Form Instance page"
	| gsFile |

	restHandler requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ((self apiConfiguration getDraftsPathFor: self getFormName in: self getApplicationName), id, '-', fileId) mode: 'rb'.
	fileContents := gsFile contentsAsUtf8.

	gsFile close.

	^fileContents! !

OrbeonFileSendApi subclass: #OrbeonSendFormInstanceFileApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonSendFormInstanceFileApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 09:47'!
doIt
	"This service is called when rendering the Draft of the form in Form Instance page"
	| gsFile |

	restHandler requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ((self apiConfiguration getInstancesPathFor: self getFormName in: self getApplicationName), id, '-', fileId) mode: 'rb'.
	fileContents := gsFile contentsAsUtf8.

	gsFile close.

	^fileContents! !

OrbeonServiceOperationApi subclass: #OrbeonFormBuilderApi
	instanceVariableNames: 'isValid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormBuilderApi methodsFor: 'other' stamp: 'brunobb 02/19/2018 11:12'!
createSavedDefinition
	"The receiver creates <anOrbeonSavedFormDefinition> named <formName> in the <OrbeonApplication> named <appName> with version number <version> with id <id> with title <title> with description <description> from XML string <xmlString>.
	In the process it create & associate the <anOrbeonSavedFormDefinition> with <anOrbeonPublishedFormDefinition>"
	| savedDefinition |

	savedDefinition := OrbeonSavedFormDefinition app: self getApplicationName form: self getFormName.

	savedDefinition id: id;
		version: version;
		title: self getTitle;
		description: self getDescription;
		setXmlString: xmlString; "here the <OrbeonPublishedFormDefinition> is created and associate to the receiver <savedDefinition>"
		updateLastModifiedTime;
		yourself.

	savedDefinition storeInApplication. "anOrbeonApplication addSavedDefinition: savedDefinition"

	(self apiConfiguration isDefinitionAuditEnableFor: savedDefinition formName in: savedDefinition getApplicationName) 
	ifTrue: [self auditStorage addDefinitionAudit: savedDefinition cloneForAudit].

	^savedDefinition! !

!OrbeonFormBuilderApi methodsFor: 'other' stamp: 'brunobb 02/19/2018 12:32'!
ifRequiredUpdateForm
	"If required the receiver rename the application and form name.
	At this point is SAFE to move everything to new location because an <AlreadyExistApplicationOrFormNameException> is NOT possible"
	| currentIdDefinition | 

	currentIdDefinition := self getOrbeonApplicationClass getSavedDefinitionWithId: id ifNone: [^self].

	((currentIdDefinition applicationName = appName) and: [currentIdDefinition formName = formName])
	ifTrue: [^self]. "no change has been made to application name and form name --> no update required"

	"move the registry to the new location and set the form name and application as requiered"
	currentIdDefinition registry
		move: currentIdDefinition 
		toApplication: appName	 
		andForm: formName! !

!OrbeonFormBuilderApi methodsFor: 'other' stamp: 'brunobb 02/15/2018 13:03'!
initialize

	super initialize.

	isValid := false.! !

!OrbeonFormBuilderApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 09:59'!
isCreationRejectedFor: latestDefinition
	"The creation is rejected for <latestDefinition> when already exist a form definition named <formName> in application named <appName> but the <ids> are different.
	This case happend when a pair <appName,formName> is saved with different id. [IN THIS PERSISTENCE LAYER THIS IS FORBIDDEN BY CODE]"

	^((self getOrbeonApplicationClass includesDefinitionNamed: self getFormName in: self getApplicationName) 
			and: [latestDefinition notNil 
				and:[(latestDefinition applicationName = self getApplicationName) 
					and:[(latestDefinition formName = self getFormName) 
						and: [latestDefinition id ~= id]]]])! !

!OrbeonFormBuilderApi methodsFor: 'Accessing' stamp: 'brunobb 02/15/2018 13:03'!
isValid
	^isValid! !

!OrbeonFormBuilderApi methodsFor: 'Updating' stamp: 'brunobb 02/15/2018 13:03'!
isValid: newValue
	isValid := newValue! !

!OrbeonFormBuilderApi methodsFor: 'other' stamp: 'brunobb 02/15/2018 13:56'!
moveFromTempPathFileOf: anOrbeonFormDefinition
	"The receiver move all files from temp path to the actual path of <anOrbeonFormDefinition>"
	| filesToMove defaultFilePath |

	filesToMove := (((GsFile contentsOfDirectory: self apiConfiguration getTempPath onClient: false) "get all current files in <path>"
			reject: [:eachPathFile | ((eachPathFile subStrings: '/') last = '.') or: [(eachPathFile subStrings: '/') last = '..']])
			collect: [:each | (each subStrings: '/') last])
			select: [:fileName | fileName includesSubstring: anOrbeonFormDefinition id].

	filesToMove isEmpty ifTrue: [^self]. "no files to move"

	defaultFilePath := self apiConfiguration getSavedDefinitionsPathFor: anOrbeonFormDefinition formName in: anOrbeonFormDefinition getApplicationName.

	filesToMove do: [:fileName | | cmd |
		cmd := 'mv ',self apiConfiguration getTempPath, '/', fileName, ' ', defaultFilePath.
		System performOnServer: cmd]! !

OrbeonFormBuilderApi subclass: #OrbeonFormBuilderPublishApi
	instanceVariableNames: 'headerVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormBuilderPublishApi methodsFor: 'other' stamp: 'brunobb 02/19/2018 11:11'!
createPublishedDefinition
	"The receiver create a new definition <anOrbeonFormDefinition> named <formName> in application <anOrbeonApplication> with id <id>"
	| orbeonSavedDefinition orbeonDefinition |

	orbeonSavedDefinition := self createSavedDefinition.

	orbeonDefinition := orbeonSavedDefinition definition. "get the <OrbeonPublishedFormDefinition>"

	^orbeonDefinition "new definition to be published"
		updateLastModifiedTime;
		version: version;
		publish;
		processXMLDefinition.! !

!OrbeonFormBuilderPublishApi methodsFor: 'other' stamp: 'brunobb 02/19/2018 13:41'!
doIt
	"The receiver publish the form named <formName> in application named <app> with id <id> title <title> description <description> and xml <xmlString>. 
	The version of the form is in <headerVersion> - orbeon parameter.
	* Calculate the version number & create <anOrbeonSavedFormDefinition> 
	* Compare latest published version with the new one --> [update the current |or| add the new one]"
	| orbeonApplication latestSavedDefinition orbeonPublishedDefinition existingVersion |

	orbeonApplication := self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: appName.

	version := (headerVersion = 'next') 
							ifTrue: [(orbeonApplication getLastFormDefinitionVersionOf: formName) + 1]
							ifFalse: [Number fromString: headerVersion].

	latestSavedDefinition := self getOrbeonApplicationClass getLatestSavedDefinition: formName app: appName ifNone: [nil].
	"is there a form definition with <formName> in application <appName> & the document_id <id> are different ??? 
	--> if <true> --> creation NOT allowed"
	(self isCreationRejectedFor: latestSavedDefinition) 
	ifFalse: [self ifRequiredUpdateForm] "if the <formName> or <appName> has been changed"
	ifTrue: [^AlreadyExistApplicationOrFormNameException signal: 'Not allowed to save [', formName,'] in application [', appName, ']'].

	orbeonPublishedDefinition := self createPublishedDefinition.

	(headerVersion = 'next') ifTrue: [orbeonApplication addPublishedDefinition: orbeonPublishedDefinition. ^self]. "is a new definition --> is added as published"

	existingVersion := orbeonApplication definitionNamed: orbeonPublishedDefinition formName version: version ifNone: [^restHandler noRouteFound: restHandler requestContext].
	(self shouldCreateAnotherVersionFor: orbeonPublishedDefinition)
	ifFalse: ["the current published definition is updated"
				existingVersion "get the last existing definition and discard <orbeonDefinition>"
					updateLastModifiedTime;
					version: orbeonPublishedDefinition version;
					xmlString: xmlString;
					publish;
					processXMLDefinition] 
	ifTrue: [orbeonApplication replaceCurrentDefinition: existingVersion with: orbeonPublishedDefinition]! !

!OrbeonFormBuilderPublishApi methodsFor: 'Accessing' stamp: 'brunobb 02/15/2018 13:07'!
headerVersion
	^headerVersion! !

!OrbeonFormBuilderPublishApi methodsFor: 'Updating' stamp: 'brunobb 02/15/2018 13:07'!
headerVersion: newValue
	headerVersion := newValue! !

!OrbeonFormBuilderPublishApi methodsFor: 'other' stamp: 'brunobb 02/15/2018 14:07'!
shouldCreateAnotherVersionFor: newFormDefinition
	"Answer whether or not a new form definition version should be created.
	If the version numbers are different --> another version shoud be created.
	If the current publish version is NOT equal to the new version <newFormDefinition> --> another version shoud be created."
	| currentDefinition comparator |

	currentDefinition := newFormDefinition getApplication definitionNamed: newFormDefinition formName version: newFormDefinition version ifNone: [^true].

	comparator := currentDefinition compareWith: newFormDefinition.

	^comparator shouldCreateAnotherVersion! !

OrbeonFormBuilderApi subclass: #OrbeonFormBuilderSaveApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormBuilderSaveApi methodsFor: 'other' stamp: 'brunobb 02/21/2018 10:32'!
doIt
	"This service is called by Orbeon when a user click on -Save- inside the Form Builder.
	A Form Definition has been saved "
	| latestSavedDefinition savedDefinition |

	latestSavedDefinition := self getOrbeonApplicationClass getLatestSavedDefinition: self getFormName app: self getApplicationName ifNone: [nil].
	version := (self getOrbeonApplicationClass getDefinitionWithId: id ifNone: [nil]) ifNil: [1] ifNotNil: [:def | def version].

	"is there a form definition with <formName> in application <appName> & the document_id <id> are different ??? 
	--> if <true> --> creation NOT allowed"

	(self isCreationRejectedFor: latestSavedDefinition) 
	ifFalse: [self ifRequiredUpdateForm] "if the <formName> or <appName> has been changed"
	ifTrue: [^AlreadyExistApplicationOrFormNameException signal: 'Not allowed to save [', self getFormName,'] in application [', self getApplicationName, ']'].

	savedDefinition := self createSavedDefinition. "here the OrbeonFormDefinition is created and associate to the receiver <savedDefinition>"

	self moveFromTempPathFileOf: savedDefinition. "move attachments if it is the case -issue #37-"

	^savedDefinition xmlString! !

OrbeonFormBuilderApi subclass: #OrbeonFormBuilderUnpublishApi
	instanceVariableNames: 'headerVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormBuilderUnpublishApi methodsFor: 'other' stamp: 'brunobb 02/22/2018 06:12'!
doIt
	"This method is called by Orbeon when a Form Definition has been unpublished with form name <formName> in application <app>"
	| application definition |

	application := self getOrbeonApplicationClass applicationNamed: self getApplicationName ifNone: [^NoApplicationException signal: 'No such application [', self getApplicationName, ']'].
	definition := application definitionNamed: self getFormName ifNone: [^NoOrbeonFormException signal: 'No such form [', self getFormName, '] in application [', self getApplicationName, ']'].

	definition switchAvailable.

	^definition xmlString! !

OrbeonFormBuilderApi subclass: #OrbeonFormDefinitionSourceApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormDefinitionSourceApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 12:52'!
doIt
	"This service is called when a click is performed on the Orbeon Form Builder Summary page.
	The Summary then should open the Orbeon Builder with the code of the clicked form."

	^((GRCodec forEncoding: 'utf-8') 
		decode: (self getOrbeonApplicationClass getSavedDefinitionWithId: id ifNone: [^NoOrbeonFormException signal: ('No Form Definition with id:' , id)]) xmlString) asString! !

OrbeonFormBuilderApi subclass: #OrbeonGetToolboxApi
	instanceVariableNames: 'headerValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonGetToolboxApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:22'!
doIt
	"This method is called by Orbeon when the Form Builder is about to be Opened.
	It show the available -Library- forms for the application named <appName> "
	| application latestDefinition |

	application := self getOrbeonApplicationClass applicationNamed: self getApplicationName ifNone: [^restHandler noRouteFound: restHandler requestContext].

	version := headerValue ifNil: [application getLastFormDefinitionVersionOf: 'library'] ifNotNil: [Number fromString: headerValue].

	latestDefinition := application getSavedDefinition: 'library' version: version ifNone: [^restHandler noRouteFound: restHandler requestContext].
	latestDefinition isDeleted ifTrue: [^restHandler noRouteFound: self requestContext].

	^((GRCodec forEncoding: 'utf-8') decode: latestDefinition xmlString) asString! !

!OrbeonGetToolboxApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 12:45'!
headerValue
	^headerValue! !

!OrbeonGetToolboxApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 12:45'!
headerValue: newValue
	headerValue := newValue! !

OrbeonServiceOperationApi subclass: #OrbeonFormRunnerApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

OrbeonFormRunnerApi subclass: #OrbeonFormDefinitionDeleteApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormDefinitionDeleteApi methodsFor: 'other' stamp: 'brunobb 02/18/2018 11:44'!
doIt
	"This method is called by Orbeon when a user click 'Delete' in a Form Definition in the Form Runner page"

	^(self getOrbeonApplicationClass logicalRemoveDefinitionWithId: id ifNone: [nil]) xmlString! !

OrbeonFormRunnerApi subclass: #OrbeonFormDefinitionDuplicateApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormDefinitionDuplicateApi methodsFor: 'other' stamp: 'brunobb 02/19/2018 09:47'!
doIt
	| savedDefinition application |

	savedDefinition := OrbeonSavedFormDefinition new.

	savedDefinition xmlString: xmlString;
		id: id;
		setMetadata; "set: application, formName, title, description"
		version: 1; "when a form is duplicate it always start at version 1"
		updateLastModifiedTime.

	application := savedDefinition application.

	savedDefinition setXmlString: savedDefinition xmlString. "create the associated <OrbeonPublishedFormDefinition>"

	application addSavedDefinition: savedDefinition.

	^savedDefinition xmlString! !

OrbeonFormRunnerApi subclass: #OrbeonFormDraftDeleteApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormDraftDeleteApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 12:30'!
doIt
	"This method is called by Orbeon when a user click 'Delete' in a Form Instance Draft in the Form Runner page"
	| application instance |

	application := self getOrbeonApplicationClass applicationNamed: self getApplicationName ifNone: [^NoApplicationException signal: 'No application named [', self getApplicationName, '] was found'].
	instance := application getAnyDraftWithId: id of: self getFormName.

	instance definition removeDraft: instance! !

OrbeonFormRunnerApi subclass: #OrbeonFormInstanceDeleteApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormInstanceDeleteApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 12:33'!
doIt
	| application instance |

	application := self getOrbeonApplicationClass applicationNamed: self getApplicationName ifNone: [^NoApplicationException signal: 'No application named [', self getApplicationName, '] was found'].

	instance := application getAnyInstanceWithId: id of: self getFormName.

	instance removeFromMainCollection! !

OrbeonFormRunnerApi subclass: #OrbeonFormInstanceDuplicateApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormInstanceDuplicateApi methodsFor: 'other' stamp: 'brunobb 02/19/2018 13:59'!
doIt
	"This method is called by Orbeon when a user click 'Duplicate' in a Form Instance in the Form Runner"
	| orbeonInstance application instanceDefinition |

	application := self getOrbeonApplicationClass applicationNamed: self getApplicationName ifNone: [^self signalNoApplicationException: self getApplicationName].

	instanceDefinition := application getDefinitionNamed: self getFormName withVersion: version ifNone: [^self signalNoFormException].

	orbeonInstance := OrbeonFormInstance new.

	orbeonInstance xmlString: xmlString;
		id: id;
		definition: instanceDefinition;
		version: version;
		updateLastModifiedTime.

	(self apiConfiguration isDeferredProcessing: self getFormName in: self getApplicationName) 
	ifTrue: [self addDeferredProcessingFor: orbeonInstance] 
	ifFalse: [orbeonInstance processXML].! !

OrbeonFormRunnerApi subclass: #OrbeonFormSaveApi
	instanceVariableNames: 'isValid username modifiedUser groupname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormSaveApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 10:52'!
groupname
	^groupname! !

!OrbeonFormSaveApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 10:52'!
groupname: newValue
	groupname := newValue! !

!OrbeonFormSaveApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 10:50'!
isValid
	^isValid! !

!OrbeonFormSaveApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 10:50'!
isValid: newValue
	isValid := newValue! !

!OrbeonFormSaveApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 10:52'!
modifiedUser
	^modifiedUser! !

!OrbeonFormSaveApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 10:52'!
modifiedUser: newValue
	modifiedUser := newValue! !

!OrbeonFormSaveApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 10:52'!
username
	^username! !

!OrbeonFormSaveApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 10:52'!
username: newValue
	username := newValue! !

OrbeonFormSaveApi subclass: #OrbeonFormSaveDraftApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormSaveDraftApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 12:04'!
doIt
	"This method is called by Orbeon when a Form is autosaved in a Form Instance page"
	| application definition orbeonDraft |

	application := self getOrbeonApplicationClass applicationNamed: self getApplicationName ifNone: [^self signalNoApplicationException: self getApplicationName].
	definition := application getDefinitionNamed: self getFormName withVersion: version ifNone: [^self signalNoFormException].
	orbeonDraft := definition getDraftWithId: id ifNone: [definition addDraft: (OrbeonFormInstance newFor: definition withId: id)].

	"execute the audit options. if <xmlString> is nil --> is a new form"
	(orbeonDraft xmlString isNil and:[self apiConfiguration isDraftAuditEnableFor: self getFormName in: self getApplicationName]) 
	ifTrue: [self auditStorage addDraftAudit: orbeonDraft cloneForAudit].

	orbeonDraft xmlString: xmlString;
		definition: definition;
		draft: 'Y';
		version: version;
		username: username; "BUG - creator set only one time"
		modifiedUser: modifiedUser;
		groupname: groupname;
		updateLastModifiedTime;
		processXMLSections. "create the sections and fields but NOT the FormFieldValues"! !

OrbeonFormSaveApi subclass: #OrbeonFormSaveFinalApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormSaveFinalApi methodsFor: 'other' stamp: 'brunobb 02/26/2018 10:51'!
doIt
	| application definition instance |

	application := self getOrbeonApplicationClass applicationNamed: self getApplicationName ifNone: [^self signalNoApplicationException: self getApplicationName].
	definition := application getDefinitionNamed: self getFormName withVersion: version ifNone: [^self signalNoFormException].
	instance := definition 
				getInstanceWithId: id 
				ifNone: [definition getDraftWithId: id ifNone: [OrbeonFormInstance newFor: definition withId: id]].

	"execute the audit options. if <xmlString> is nil --> is a new form"
	(instance xmlString notNil and:[self apiConfiguration isInstanceAuditEnableFor: self getFormName in: self getApplicationName]) 
	ifTrue: [self auditStorage addInstanceAudit: instance cloneForAudit].

	instance xmlString: xmlString;
		draft: 'N';
		definition: definition;
		version: version;
		username: username; "BUG - creator set only one time"
		modifiedUser: modifiedUser;
		groupname: groupname;
		isValid: isValid;
		updateLastModifiedTime.

	(self apiConfiguration isDeferredProcessing: self getFormName in: self getApplicationName) 
	ifTrue: [self addDeferredProcessingFor: instance] 
	ifFalse: [instance processXML].

	definition removeDraft: instance. "this is the final version so we remove the current draft if any"! !

OrbeonFormRunnerApi subclass: #OrbeonFormSourceApi
	instanceVariableNames: 'group username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

OrbeonFormSourceApi subclass: #OrbeonFormDraftSourceApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormDraftSourceApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 07:36'!
getInstance

	^self getOrbeonApplicationClass getAnyDraftWith: id formName: self getFormName form in: self getApplicationName ifNone: [^self signalNoFormException]! !

OrbeonFormSourceApi subclass: #OrbeonFormInstanceSourceApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFormInstanceSourceApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 07:35'!
getInstance

	^self getOrbeonApplicationClass getAnyInstanceWith: id formName: self getFormName in: self getApplicationName ifNone: [^self signalNoFormException]! !

!OrbeonFormSourceApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 07:36'!
doIt
	"This service is called when a click is performed on the Orbeon Form Summary page.
	The Summary then should open the Form Instance (view/edit mode ) in the corresponding form definition (template).
	This sevice is used in combination with #getDefinitionForFormInstanceWithId:form:app: that <get> the form definition (template) to the form with id <id>"
	| instance permissions |

	instance := self getInstance.

	permissions := instance getPermissionsForUser: username inGroup: group with: instance definition.
	
	restHandler requestContext response headerAt: 'orbeon-operations' put: permissions.

	^((GRCodec forEncoding: 'utf-8') decode: instance xmlString) asString! !

!OrbeonFormSourceApi methodsFor: 'Accessing' stamp: 'brunobb 02/17/2018 07:29'!
group
	^group! !

!OrbeonFormSourceApi methodsFor: 'Updating' stamp: 'brunobb 02/17/2018 07:29'!
group: newValue
	group := newValue! !

!OrbeonFormSourceApi methodsFor: 'Accessing' stamp: 'brunobb 02/17/2018 07:29'!
username
	^username! !

!OrbeonFormSourceApi methodsFor: 'Updating' stamp: 'brunobb 02/17/2018 07:29'!
username: newValue
	username := newValue! !

OrbeonFormRunnerApi subclass: #OrbeonFrPageApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonFrPageApi methodsFor: 'other' stamp: 'brunobb 02/21/2018 17:00'!
doIt
	"This service is called when accessing Form Runner Home: ../orbeon/fr/ "
	| xmlWriter |

	xmlWriter := XMLWriter new.
	xmlWriter writeWith: [:writer | 
		writer tag: 'forms' with: [self getOrbeonApplicationClass getLastDefinitions do: [:eachDef | 
			self getXmlNodeForRunnerHome: eachDef with: writer]].
	].
	^xmlWriter contents! !

!OrbeonFrPageApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 12:55'!
getXmlNodeForRunnerHome: anOrbeonFormDefinition with: anXMLWriter
	"The receiver create a XML structure to display the definition <anOrbeonFormDefinition> in ../orbeon/fr page"

	anXMLWriter tag: 'form' with: [
		anXMLWriter tag: 'application-name' with: anOrbeonFormDefinition getApplicationName.
		anXMLWriter tag: 'form-name' with: anOrbeonFormDefinition formName.
		anXMLWriter tag: 'title' with: anOrbeonFormDefinition title.
		anXMLWriter tag: 'description' with: anOrbeonFormDefinition description.
		anXMLWriter tag: 'last-modified-time' with: anOrbeonFormDefinition modifiedTime asOrbeonDateTimeString.
		anXMLWriter tag: 'available' with: anOrbeonFormDefinition isAvailable printString.
	].! !

OrbeonServiceOperationApi subclass: #OrbeonSearchApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

OrbeonSearchApi subclass: #OrbeonGenericGetApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

OrbeonGenericGetApi subclass: #OrbeonAllFormDefinitionVersionsApi
	instanceVariableNames: 'allversions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonAllFormDefinitionVersionsApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:20'!
allversions
	^allversions! !

!OrbeonAllFormDefinitionVersionsApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:20'!
allversions: newValue
	allversions := newValue! !

!OrbeonAllFormDefinitionVersionsApi methodsFor: 'other' stamp: 'brunobb 02/19/2018 13:20'!
doIt
	"Implemented as stated in: 
	https://doc.orbeon.com/form-runner/api/persistence/forms-metadata.html#returning-all-form-definition-versions"
	| application registry xmlWriter getAllVersions |

	application := self getOrbeonApplicationClass applicationNamed: self getApplicationName ifNone: [^restHandler noRouteFound: restHandler requestContext].

	registry := application registryForFormNamed: self getFormName ifNone: [^restHandler noRouteFound: restHandler requestContext].

	getAllVersions := allversions = 'true'.
	getAllVersions ifFalse: [^registry getLastVersionNumber].
 
	xmlWriter := XMLWriter new.

	xmlWriter writeWith: [:writer | 
		writer tag: 'forms' with: [
			registry currentVersions do: [:publishedVersion | self generateXmlNodeForFormBuilderVersionList: publishedVersion with: writer].
		].
	].

	^xmlWriter contents! !

!OrbeonAllFormDefinitionVersionsApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:23'!
generateXmlNodeForFormBuilderVersionList: anOrbeonPublishedFormDefinition with: anXMLWriter
	"The receiver create a XML structure to display the definition <anOrbeonFormDefinition> in ../orbeon/fr page"
	| attributes |

	attributes := OrderedCollection new.
	attributes add: ('operations' -> '*').

	anXMLWriter tag: 'form' attributes: attributes asArray  with: [
		anXMLWriter tag: 'application-name' with: anOrbeonPublishedFormDefinition getApplicationName.
		anXMLWriter tag: 'form-name' with: anOrbeonPublishedFormDefinition formName.
		anXMLWriter tag: 'title' with: anOrbeonPublishedFormDefinition title.
		anXMLWriter tag: 'description' with: anOrbeonPublishedFormDefinition description.
		anXMLWriter tag: 'last-modified-time' with: anOrbeonPublishedFormDefinition modifiedTime asOrbeonDateTimeString.
		anXMLWriter tag: 'form-version' with: anOrbeonPublishedFormDefinition version printString.
	].! !

OrbeonGenericGetApi subclass: #OrbeonDefinitionForFormInstanceApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonDefinitionForFormInstanceApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:49'!
doIt
	"This service is called when a click is performed on the Orbeon Form Summary page (or go directly to edit/view page of a form). The Summary then open the Form Instance in it's corresponding form definition.
	This service is used in combination of #getXmlOfFormInstanceWithId:form:app: to <get> the actual data of the form"
	| application orbeonDefinition instance |

	application := self getOrbeonApplicationClass applicationNamed: self getApplicationName ifNone: [^self signalNoFormException].

	instance := self getOrbeonApplicationClass getAnyInstanceWith: id formName: self getFormName in: self getApplicationName 
							ifNone: [self getOrbeonApplicationClass getAnyDraftWith: id formName: self getFormName in: self getApplicationName 
												ifNone: [^self signalNoFormException]].

	orbeonDefinition := instance definition.

	restHandler requestContext response headerAt: 'orbeon-form-definition-version' put: orbeonDefinition version printString.

	^((GRCodec forEncoding: 'utf-8') decode: orbeonDefinition xmlString) asString! !

OrbeonGenericGetApi subclass: #OrbeonLastFormDefinitionSourceApi
	instanceVariableNames: 'headerVersionValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonLastFormDefinitionSourceApi methodsFor: 'other' stamp: 'brunobb 02/23/2018 18:20'!
doIt
	"This method is called by Orbeon when a Form Definition (inside the Builder) is about to be Published.
	This method answer the latest version of the form definition <formName> in application <app>.
	Using the header <orbeon-form-definition-version> to set the version number.
	It also called when a new Form Instance page is about to be displayed (app/form/new)"
	| application latestDefinition headerVersion |

	application := self getOrbeonApplicationClass applicationNamed: self getApplicationName ifNone: [^restHandler noRouteFound: restHandler requestContext].

	headerVersion := headerVersionValue ifNil: [application getLastFormDefinitionVersionOf: self getFormName] ifNotNil: [Number fromString: headerVersionValue].

	latestDefinition := application getSavedDefinition: formName version: headerVersion ifNone: [^restHandler noRouteFound: restHandler requestContext].
	latestDefinition isDeleted ifTrue: [^restHandler noRouteFound: restHandler requestContext].
	"latestDefinition definition isAvailable ifFalse: [^restHandler noRouteFound: restHandler requestContext]."

	^((GRCodec forEncoding: 'utf-8') decode: latestDefinition xmlString) asString! !

!OrbeonLastFormDefinitionSourceApi methodsFor: 'Accessing' stamp: 'brunobb 02/19/2018 13:35'!
headerVersionValue
	^headerVersionValue! !

!OrbeonLastFormDefinitionSourceApi methodsFor: 'Updating' stamp: 'brunobb 02/19/2018 13:35'!
headerVersionValue: newValue
	headerVersionValue := newValue! !

!OrbeonSearchApi class methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 12:54'!
initializeLog

	log := OrderedCollection new.! !

!OrbeonSearchApi class methodsFor: 'Accessing' stamp: 'BrunoBB 10/15/2015 12:56'!
log
	^log! !

!OrbeonSearchApi class methodsFor: 'Updating' stamp: 'BrunoBB 10/15/2015 12:56'!
log: newValue
	log := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 10/15/2015 12:55'!
addToLog

	^self class log add: self! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 12/22/2016 14:33'!
getPageNumber
	"The receiver extract the page number from the XMLDocument <xmlDocument>.
	This number is used for paging forms in Orbeon web pages.
	The page number is the current page to show.(The first time is 1).
	For example with 1 2 3 4 5 paging and each index with 10 forms --> page number = 3 --> display pages from 30 to 39"
	| pageNumberNodes pageNumberNode |

	pageNumberNodes := xmlSearchDefinitionDocument allElementsNamed: 'page-number'.
	pageNumberNodes isEmpty ifTrue: [^pageNumber := 1].

	pageNumberNode := pageNumberNodes last.
	pageNumberNode strings isEmpty ifTrue: [^pageNumber := 1].

	^pageNumber := Number fromString: pageNumberNode strings last! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 11:47'!
getPageSize
	"The receiver extract the page size from the xml document <xmlDocument>.
	The page size set how many forms are displayed in a single page.
	This number is used for paging Orbeon Forms in Summaries"
	| pageSizeNodes pageSizeNode |

	pageSizeNodes := xmlSearchDefinitionDocument allElementsNamed: 'page-size'.
	pageSizeNodes isEmpty ifTrue: [^pageSize := 10].

	pageSizeNode := pageSizeNodes last.
	pageSizeNode strings isEmpty ifTrue: [^pageSize := 10].

	^pageSize := Number fromString: pageSizeNode strings last! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
group
	^group! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
group: newValue
	group := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 08/21/2016 14:12'!
initialize

	super initialize.

	searchValues := Dictionary new.! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 12:50'!
isGenericSearch

	^queryNodes anySatisfy: [:each | each isGeneric]! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
pageFrom
	"The receiver answer the start page to display search results"

	^self pageTo - pageSize + 1! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
pageNumber
	^pageNumber! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
pageNumber: newValue
	pageNumber := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
pageSize
	^pageSize! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
pageSize: newValue
	pageSize := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
pageTo
	"The receiver answer the top limit page to display search results"

	^pageSize * pageNumber! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
queryNodes
	^queryNodes! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
queryNodes: newValue
	queryNodes := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 08/21/2016 13:56'!
queryString
	^queryString! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 08/21/2016 13:56'!
queryString: newValue
	queryString := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
resultCollection
	^resultCollection! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
resultCollection: newValue
	resultCollection := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
resultSize

	^resultCollection size! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
searchTotal
	^searchTotal! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
searchTotal: newValue
	searchTotal := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 08/21/2016 14:11'!
searchValues
	^searchValues! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 08/21/2016 14:11'!
searchValues: newValue
	searchValues := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
total
	^total! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
total: newValue
	total := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
user
	^user! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
user: newValue
	user := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
xmlSearchDefinitionDocument
	^xmlSearchDefinitionDocument! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
xmlSearchDefinitionDocument: newValue
	xmlSearchDefinitionDocument := newValue! !

OrbeonSearchApi subclass: #OrbeonSummaryApi
	instanceVariableNames: 'xmlSearchDefinitionDocument user group resultCollection total searchTotal pageNumber pageSize queryNodes queryString searchValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

OrbeonSummaryApi class
	instanceVariableNames: 'log queryErrors'!

OrbeonSummaryApi subclass: #OrbeonDefinitionSearchApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonDefinitionSearchApi methodsFor: 'other' stamp: 'brunobb 02/20/2018 08:48'!
applyQueryToFormDefinitions: anOrderedCollection
	"The receiver apply the query contained in xml document <xmlDocument> to all <OrbeonSavedFormDefinition> in collection <anOrderedCollection>"
	| queryFields result conditions |

	queryFields := Dictionary new. "dictionary with the criteria to search"
	conditions := OrderedCollection new.
	result := anOrderedCollection select: [:each | each deleted = 'N']. "exclude deleted definitions"

	queryNodes := (xmlSearchDefinitionDocument allElementsNamed: 'query') do: [:node | "get the criteria from <xmlDocument>"
		node strings notEmpty ifTrue: [queryFields at: (node attributeAt: 'name') put: node strings last]].

	"apply all available criteria to the result collection <result>"
	queryFields keysAndValuesDo: [:key :value |
		(key = 'application-name') ifTrue: [conditions add: [:each | value match: each getApplicationName]].
		(key = 'form-name') ifTrue: [conditions add: [:each | value match: each formName]].
		(key = 'title') ifTrue: [conditions add: [:each | value match: each title]].
		(key = 'description') ifTrue: [conditions add: ([:each | value match: each description])].
		(key = '') ifTrue: [conditions add: [:each | (value match: each getApplicationName) or: [(value match: each formName) or: [(value match: each title) or: [(value match: each description)]]]]
					].
	].

	conditions do: [:conditionBlock | result := result select: conditionBlock].

	^resultCollection := result! !

!OrbeonDefinitionSearchApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 12:04'!
doIt
	| savedDefinitions |

	savedDefinitions := self getOrbeonApplicationClass getAllSavedDefinitions.
	searchTotal := savedDefinitions size.

	self applyQueryToFormDefinitions: savedDefinitions.! !

!OrbeonDefinitionSearchApi methodsFor: 'builder summary' stamp: 'BrunoBB 12/30/2016 03:27'!
generateXmlAnswerForBuilderSummary
	"The receiver generate a XML string for the <anOrbeonFormInstanceDefinition> in collection <definitionCollection> where total of instance is <searchTotal>.
	<definitionCollection> is filtered collection so definitionCollection size ~= searchTotal"
	| xmlWriter |

	xmlWriter := XMLWriter new.

	xmlWriter writeWith: [:writer | | tag |
		tag := writer tag: 'documents' attributes: self getArrayOfOrbeonHeaders. "create the header of the XML"
		"generate XML nodes for each element in <definitionCollection>"
		tag with: [self generateXmlNodeForAllDefinitionWith: xmlWriter]

	].

	 ^xmlWriter contents! !

!OrbeonDefinitionSearchApi methodsFor: 'builder summary' stamp: 'BrunoBB 09/18/2015 13:39'!
generateXmlNodeForAllDefinitionWith: aXMLWriter
	"The receiver generate a XML structure for the definition <anOrbeonFormInstanceDefinition>.
	Defaults fields to show (createdTime, draft, modifiedTime, app, form, title, description).
	This is method is for Form Builder Summary"
	| to |

	to := (self pageTo >= self resultSize) ifTrue: [self resultSize] ifFalse: [self pageTo].

	(resultCollection copyFrom: self pageFrom to: to) do: [:each | self generateXmlNodeForDefinition: each with: aXMLWriter]! !

!OrbeonDefinitionSearchApi methodsFor: 'builder summary' stamp: 'BrunoBB 12/30/2016 04:13'!
generateXmlNodeForDefinition: anOrbeonSavedFormDefinition with: aXMLWriter
	"The receiver generate a XML structure for the definition <anOrbeonFormInstanceDefinition>.
	Defaults fields to show (createdTime, draft, modifiedTime, app, form, title, description).
	This is method is for Form Builder Summary"
	| nodeAttributes tag |

	nodeAttributes := OrderedCollection new
		add: 'created' -> anOrbeonSavedFormDefinition createdTime asOrbeonDateTimeString;
		add: 'draft' -> anOrbeonSavedFormDefinition printDraft;
		add: 'last-modified' -> anOrbeonSavedFormDefinition modifiedTime asOrbeonDateTimeString;
		add: 'name' -> anOrbeonSavedFormDefinition id;
		add: 'operations' -> '*';  "in form builder when a user has access defined in [form-builder-permissions.xml] --> it has ALL permissions (create/read/update/delete)"
		asArray.						"only instances make user of permissions"

	tag := aXMLWriter tag: 'document' attributes: nodeAttributes.

	tag with: [aXMLWriter tag: 'details' 
									with: [aXMLWriter tag: 'detail' with: anOrbeonSavedFormDefinition getApplicationName.
											aXMLWriter tag: 'detail' with: anOrbeonSavedFormDefinition formName.
											aXMLWriter tag: 'detail' with: anOrbeonSavedFormDefinition title.
											aXMLWriter tag: 'detail' with: anOrbeonSavedFormDefinition description.]]! !

!OrbeonDefinitionSearchApi methodsFor: 'other' stamp: 'BrunoBB 08/21/2016 12:21'!
getArrayOfOrbeonHeaders
	"The receiver creates a collection with the header of the XML to show in the Summary page"

	^OrderedCollection new
		add: 'xmlns:ev' -> 'http://www.w3.org/2001/xml-events';
		add: 'xmlns:f' -> 'http//www.orbeon.com/function';
		add: 'xmlns:frf' -> 'java:org.orbeon.oxf.fr.FormRunner';
		add: 'xmlns:odt' -> 'http://orbeon.org/oxf/xml/datatypes';
		add: 'xmlns:oxf' -> 'http://www.orbeon.com/oxf/processors';
		add: 'xmlns:p' -> 'http://www.orbeon.com/oxf/pipeline';
		add: 'xmlns:saxon' -> 'http://saxon.sf.net/';
		add: 'xmlns:sql' -> 'http://orbeon.org/oxf/xml/sql';
		add: 'xmlns:xf' -> 'http://www.w3.org/2002/xforms';
		add: 'xmlns:xi' -> 'http://www.w3.org/2001/XInclude';
		add: 'xmlns:xpl' -> 'java:org.orbeon.oxf.pipeline.api.FunctionLibrary';
		add: 'xmlns:xs' -> 'http://www.w3.org/2001/XMLSchema';
		add: 'xmlns:xxf' -> 'http://orbeon.org/oxf/xml/xforms';
		add: 'page-size' -> pageSize printString;
		add: 'total' -> searchTotal printString;
		add: 'search-total' -> resultCollection size printString;
		asArray! !

OrbeonSummaryApi subclass: #OrbeonInstanceSearchApi
	instanceVariableNames: 'application lastFormDefinition mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!OrbeonInstanceSearchApi class methodsFor: 'other' stamp: 'BrunoBB 09/30/2015 15:17'!
for: anOrbeonApplication formName: formName

	^super new initialize
		application: anOrbeonApplication;
		setFormName: formName;
		yourself! !

!OrbeonInstanceSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/30/2015 15:16'!
application
	^application! !

!OrbeonInstanceSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/30/2015 15:16'!
application: newValue
	application := newValue! !

!OrbeonInstanceSearchApi methodsFor: 'queries' stamp: 'brunobb 02/16/2018 10:09'!
createGenericGsQueriesFor: collectionOfOrbeonQueryNode
	"The receiver create the <GsQuery> for a generic search.
	The user has set a value to search but the field name is NOT know. Can be any field search.
	The generic search behave like OR search any match with any field is valid"
	| nodesWithQuery gsQueries |

	gsQueries := Dictionary new.
	nodesWithQuery := collectionOfOrbeonQueryNode select: [:each | each hasValueAndNoName].
	nodesWithQuery isEmpty ifTrue: [^#()].

	nodesWithQuery do: [:each | 
		each beGeneric. "set the query node as generic -like an OR search-"
		(application getAllSearchFieldsOf: formName) do: [:fieldName | | type stream gsQuery stValue |
			stream := PrintStream on: String new.
			type := lastFormDefinition stTypeOf: each name.
			stValue := (type == String) ifTrue: [each value] ifFalse: [type fromOrbeonString: each value].
			stream nextPutAll: '(each.value = stValue) & '.
			queryString := stream contents allButLast: 3.
			gsQuery := GsQuery fromString: queryString.
			gsQuery bind: 'stValue' to: stValue.
			gsQueries at: fieldName put: gsQuery.
			stream close]].

	^gsQueries! !

!OrbeonInstanceSearchApi methodsFor: 'queries' stamp: 'brunobb 02/20/2018 09:37'!
createGsQueriesFor: collectionOfOrbeonQueryNode
	"The receiver answer a Dictionary of GsQuery from the collection <collectionOfOrbeonQueryNode> of query nodes <OrbeonQueryNode>.
	The dictionary's keys is the name of the field and the value is the GsQuery"
	| nodesWithQuery gsQueries |

	gsQueries := Dictionary new.
	nodesWithQuery := collectionOfOrbeonQueryNode select: [:each | each isSearchAndHasValue].
	nodesWithQuery isEmpty ifTrue: [^self createGenericGsQueriesFor: collectionOfOrbeonQueryNode].

	nodesWithQuery do: [:each | | stream type gsQuery stValue |
		stream := PrintStream on: String new.
		type := lastFormDefinition stTypeOf: each name.
		searchValues at: each name put: each value.
		stValue := (type == String) ifTrue: [each value] ifFalse: [type fromOrbeonString: each value].
		stream nextPutAll: '(each.value = stValue) & '.
		queryString := stream contents allButLast: 3.
		gsQuery := GsQuery fromString: queryString. 
		gsQuery bind: 'stValue' to: stValue.
		gsQueries at: each name put: gsQuery.
		stream close.].

	^gsQueries! !

!OrbeonInstanceSearchApi methodsFor: 'queries' stamp: 'BrunoBB 10/03/2015 10:45'!
createQueryNodes
	"The receiver extract the -query nodes- from the XML Document <xmlDocument>.
	These -query nodes- are used to query the Orbeon Summary and to show summary fields"

	queryNodes := OrderedCollection new.

	(xmlSearchDefinitionDocument allElementsNamed: 'query') do: [:node | | queryNode value |
		value := node strings notEmpty ifTrue: [node strings last] ifFalse: [nil]. "get the field Value to Search"
		queryNode := OrbeonQueryNode new name: (node attributeAt: 'name');
								path: (node attributeAt: 'path');
								type: (node attributeAt: 'type');
								control: (node attributeAt: 'control');
								searchField: (node attributeAt: 'search-field'); 
								summaryField: (node attributeAt: 'summary-field'); 
								match: (node attributeAt: 'match');  "get the Search type"
								value: value;
								yourself.
		queryNodes add: queryNode.
		].

	^queryNodes! !

!OrbeonInstanceSearchApi methodsFor: 'queries' stamp: 'brunobb 02/16/2018 12:03'!
doIt
	"The receiver execute the query defined in it's self. Storing the result in <resultCollection>"

	"if there is NO query nodes --> Orbeon is searching for a draft for a given form <id>"
	queryNodes isEmpty ifTrue: [mode:= #draft. ^self executeQuerySearchFormWithDraft]. 

	(queryNodes allSatisfy: [:each | each value == nil]) "if has query nodes but Without Values --> Generic Summary without Search"
	ifTrue: [mode:= #noSearch. ^self executeQueryWithoutSearchCriteria].

	mode := #search.
	^self executeQueryWithSearchCriteria "if has query nodes but With Values --> Summary with Field Search"! !

!OrbeonInstanceSearchApi methodsFor: 'queries' stamp: 'BrunoBB 04/28/2016 11:09'!
executeQuerySearchFormWithDraft
	| draftNode draftId |

	draftNode := xmlSearchDefinitionDocument allElementsNamed: 'drafts'.

	draftNode isEmpty ifTrue: [^resultCollection := #()].

	draftNode := draftNode last.
	"if there is an id <for-document-id> --> Orbeon is searching for a draft, if NOT --> is a Summary of drafts (there are more than one draft stored --> we are going to show all of them)"
	draftId := draftNode attributeAt: 'for-document-id' ifAbsent: [^self executeQueryWithoutSearchCriteria].

	^resultCollection := (application getAnyDraftWithId: draftId of: lastFormDefinition formName)
		ifNil: [#()]
		ifNotNil: [:value | OrderedCollection with: value]! !

!OrbeonInstanceSearchApi methodsFor: 'queries' stamp: 'brunobb 02/16/2018 10:09'!
executeQueryWithoutSearchCriteria
	| drafts formsInRange stream instancesShift draftsSize draftsNodes |

	drafts :=  self getAllDrafts.
	draftsNodes := xmlSearchDefinitionDocument descendentElementsNamed: 'drafts'.

	(draftsNodes notEmpty and: [((draftsNodes first attributeAt: 'for-never-saved-document') = 'true') and: [draftsNodes first contentString = 'only']]) "drafts to display"
	ifTrue: [total := drafts size.
			^resultCollection := drafts].

	formsInRange := OrderedCollection new.
	instancesShift := (self pageFrom = 1) ifTrue: [1] ifFalse: [self pageFrom - drafts size].
	draftsSize :=  (self pageFrom = 1) ifTrue: [drafts size] ifFalse: [0].

	stream := (application registryForFormNamed: formName ifNone: [nil]) getIteratorFor: user group: group. "answer a specific iterator to go through instances"
	stream fromIndex: instancesShift - 1;
				toIndex: (instancesShift - 1) + pageSize - draftsSize.

	formsInRange := stream getCollection.

	total := stream "formsInRange" size + drafts size.
	stream close.

	draftsNodes isEmpty 
	ifTrue: [^resultCollection :=  (self pageFrom = 1) ifTrue: [drafts, formsInRange] ifFalse: [formsInRange]].

	^resultCollection :=  (self pageFrom = 1) ifTrue: [drafts, formsInRange] ifFalse: [formsInRange]! !

!OrbeonInstanceSearchApi methodsFor: 'queries' stamp: 'brunobb 02/20/2018 09:28'!
executeQueryWithSearchCriteria
	"The receiver answer a collection with the result of applying the collection of queries to the form definition <anOrbeonFormDefinition>"
	| gsQueries result andResult orResult allDefinitions |

	total := 0.
	result := Dictionary new.
	"create all <GsQuery> for each field with a search value"
	gsQueries := self createGsQueriesFor: queryNodes. "aDictionary (fieldName-->aGsQuery)"
	allDefinitions := self getAllDefinitions.
	gsQueries keysAndValuesDo: [:fieldName :gsQuery | | rcIdentitySet |
		result at: fieldName put: OrderedCollection new.
		allDefinitions do: [:eachDef |
			rcIdentitySet := eachDef fieldInstancesOf: fieldName."get the collection of ALL field's values of <fieldName>"
			gsQuery on: rcIdentitySet. "set the collection of the <GsQuery>"
			(result at: fieldName) addAll: gsQuery queryResult.
			total := total + rcIdentitySet size]]."Excecute the <GsQuery> and store it on dictionary <result>"

	result isEmpty ifTrue: [^resultCollection := OrderedCollection new].

	"perform an OR search if OR is setted - (OR or AND search is useful when the search has more than one search criteria)"
	((self apiConfiguration typeSearchIsOr: lastFormDefinition formName in: application applicationName) or: [self isGenericSearch])
	ifTrue: [orResult := Set new.
		result do: [:queryResult | orResult addAll: queryResult].
		orResult  := (orResult collect: [:each | each parentObject]) asOrderedCollection.
		^self filterAuthorizedInstancesIn: orResult "filter by permissions"].

	"perform an AND search"
	andResult := (OrderedCollection withAll: (result at: result keys asArray first)) collect: [:each | each parentObject].

	result asOrderedCollection allButFirst do: [:queryResult | andResult := andResult intersection: (queryResult collect: [:each | each parentObject])].
	"filter by permissions"
	^self filterAuthorizedInstancesIn: andResult asOrderedCollection! !

!OrbeonInstanceSearchApi methodsFor: 'queries' stamp: 'BrunoBB 09/30/2015 15:23'!
filterAuthorizedInstancesIn: anOrderedCollection
	"The receiver filter the form instances in <anOrderedCollection>. 
	Each instance in <anOrderedCollection> is checked if it has read authotization for user <username> or group <group> using the permissions defined in <anOrbeonFormDefinition>"

	^resultCollection := (anOrderedCollection select: [:each | 
														each deleted = 'N' and: 
															[(each hasUser: user readAccessUsing: lastFormDefinition permissions) 
																or: [each hasRole: group readAccessUsing: lastFormDefinition permissions]]])! !

!OrbeonInstanceSearchApi methodsFor: 'summary' stamp: 'BrunoBB 08/21/2016 15:51'!
generateXmlAnswer
	"The receiver generate a XML string for each element in <instanceCollection> where the values to show are the summary fields contained in <collectionOfOrbeonQueryNode>.
	The form definition <formDefinition> the username <username> and the group <group> are used to get the permissions of the current user over the forms"
	| xmlWriter |

	xmlWriter := XMLWriter new.

	xmlWriter writeWith: [:writer | | tag |
		tag := writer tag: 'documents' attributes: self getArrayOfOrbeonHeaders. "create the header of the XML"

		"generate a XML node for each form in <instanceCollection>"
		tag with: [self generateXmlNodeForAllWith: xmlWriter].
	].

	 ^xmlWriter contents! !

!OrbeonInstanceSearchApi methodsFor: 'summary' stamp: 'BrunoBB 01/02/2017 04:38'!
generateXmlNodeFor: anOrbeonFormInstance with: aXMLWriter
	"The receiver generate XML nodes for summary fields of form <anOrbeonFormInstance> with form definition <formDefinition>.
	The summary fields to show are in <collectionOfNames>.
	The form definition <formDefinition> the username and <username> the group <group> are used to get the permissions"
	| nodeAttributes tag |

	nodeAttributes := OrderedCollection new
		add: 'created' -> anOrbeonFormInstance createdTime asOrbeonDateTimeString;
		add: 'draft' -> anOrbeonFormInstance printDraft;
		add: 'last-modified' -> anOrbeonFormInstance modifiedTime asOrbeonDateTimeString;
		add: 'name' -> anOrbeonFormInstance id;
		add: 'operations' -> (anOrbeonFormInstance getPermissionsForUser: user inGroup: group with: lastFormDefinition);
		asArray.

	tag := aXMLWriter tag: 'document' attributes: nodeAttributes.

	tag with: [aXMLWriter 
						tag: 'details' 
						with: [(anOrbeonFormInstance getValueOfFields: self summaryFields) "get the values of fields to display in the summary"
									do: [:each | aXMLWriter tag: 'detail' with: each]]].! !

!OrbeonInstanceSearchApi methodsFor: 'summary' stamp: 'BrunoBB 08/21/2016 17:05'!
generateXmlNodeForAllWith: aXMLWriter
	"The receiver generate XML nodes for summary fields of form <anOrbeonFormInstance> with form definition <formDefinition>.
	The summary fields to show are in <collectionOfNames>.
	The form definition <formDefinition> the username and <username> the group <group> are used to get the permissions"
	| to presenterCollection |

	to := (self pageTo >= self resultSize) ifTrue: [self resultSize] ifFalse: [self pageTo].

	presenterCollection := (mode = #noSearch)
		ifTrue: [resultCollection]
		ifFalse: [resultCollection copyFrom: self pageFrom to: to].

	presenterCollection do: [:each | self generateXmlNodeFor: each with: aXMLWriter]! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 10:09'!
getAllDefinitions
	"Answer a collection with ALL form definitions where the search is applied"

	^application getAllDefinitionsNamed: formName! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 10:09'!
getAllDrafts
	"The receiver answer a collection with all drafts of ALL published definitions."
	| drafts |

	drafts := OrderedCollection new.

	(application getAllDefinitionsNamed: formName ifNone: [^#()]) 
		do: [:each | drafts addAll: (each getAllDraftsFor: user orGroup: group)].

	^drafts! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 10:09'!
getAllKeys

	^application getAllInstancesKeysOfFormNamed: formName! !

!OrbeonInstanceSearchApi methodsFor: 'queries' stamp: 'BrunoBB 12/30/2016 08:59'!
getArrayOfOrbeonHeaders
	"The receiver creates a collection with the header of the XML to show in the Summary page"

	^OrderedCollection new
		add: 'xmlns:ev' -> 'http://www.w3.org/2001/xml-events';
		add: 'xmlns:f' -> 'http//www.orbeon.com/function';
		add: 'xmlns:frf' -> 'java:org.orbeon.oxf.fr.FormRunner';
		add: 'xmlns:odt' -> 'http://orbeon.org/oxf/xml/datatypes';
		add: 'xmlns:oxf' -> 'http://www.orbeon.com/oxf/processors';
		add: 'xmlns:p' -> 'http://www.orbeon.com/oxf/pipeline';
		add: 'xmlns:saxon' -> 'http://saxon.sf.net/';
		add: 'xmlns:sql' -> 'http://orbeon.org/oxf/xml/sql';
		add: 'xmlns:xf' -> 'http://www.w3.org/2002/xforms';
		add: 'xmlns:xi' -> 'http://www.w3.org/2001/XInclude';
		add: 'xmlns:xpl' -> 'java:org.orbeon.oxf.pipeline.api.FunctionLibrary';
		add: 'xmlns:xs' -> 'http://www.w3.org/2001/XMLSchema';
		add: 'xmlns:xxf' -> 'http://orbeon.org/oxf/xml/xforms';
		add: 'page-size' -> pageSize printString;
		add: 'total' -> total printString;
		add: 'search-total' -> ((mode = #search) ifTrue: [resultCollection size printString] ifFalse: [total printString]);
		asArray! !

!OrbeonInstanceSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/30/2015 15:16'!
lastFormDefinition
	^lastFormDefinition! !

!OrbeonInstanceSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/30/2015 15:16'!
lastFormDefinition: newValue
	lastFormDefinition := newValue! !

!OrbeonInstanceSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 08/21/2016 16:12'!
mode
	^mode! !

!OrbeonInstanceSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 08/21/2016 16:12'!
mode: newValue
	mode := newValue! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 10:09'!
setFormName: aString
	"Set the variable <formName> of the receiver with <aString> and set the last published form with name <aString>"

	formName := aString.

	lastFormDefinition := application definitionNamed: aString ifNone: [^NoOrbeonFormException signal: ('No Form Definition [', formName, ']')].! !

!OrbeonInstanceSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 13:20'!
summaryFields

	^queryNodes select: [:each | each isSummary] thenCollect: [:each | each name].! !

!OrbeonSummaryApi class methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:03'!
initializeLog

	log := OrderedCollection new.! !

!OrbeonSummaryApi class methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:03'!
log
	^log! !

!OrbeonSummaryApi class methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:04'!
log: newValue
	log := newValue! !

!OrbeonSummaryApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:02'!
addToLog

	^self class log add: self! !

!OrbeonSummaryApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:02'!
getPageNumber
	"The receiver extract the page number from the XMLDocument <xmlDocument>.
	This number is used for paging forms in Orbeon web pages.
	The page number is the current page to show.(The first time is 1).
	For example with 1 2 3 4 5 paging and each index with 10 forms --> page number = 3 --> display pages from 30 to 39"
	| pageNumberNodes pageNumberNode |

	pageNumberNodes := xmlSearchDefinitionDocument allElementsNamed: 'page-number'.
	pageNumberNodes isEmpty ifTrue: [^pageNumber := 1].

	pageNumberNode := pageNumberNodes last.
	pageNumberNode strings isEmpty ifTrue: [^pageNumber := 1].

	^pageNumber := Number fromString: pageNumberNode strings last! !

!OrbeonSummaryApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:02'!
getPageSize
	"The receiver extract the page size from the xml document <xmlDocument>.
	The page size set how many forms are displayed in a single page.
	This number is used for paging Orbeon Forms in Summaries"
	| pageSizeNodes pageSizeNode |

	pageSizeNodes := xmlSearchDefinitionDocument allElementsNamed: 'page-size'.
	pageSizeNodes isEmpty ifTrue: [^pageSize := 10].

	pageSizeNode := pageSizeNodes last.
	pageSizeNode strings isEmpty ifTrue: [^pageSize := 10].

	^pageSize := Number fromString: pageSizeNode strings last! !

!OrbeonSummaryApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:02'!
group
	^group! !

!OrbeonSummaryApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:02'!
group: newValue
	group := newValue! !

!OrbeonSummaryApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:02'!
initialize

	super initialize.

	searchValues := Dictionary new.! !

!OrbeonSummaryApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:02'!
isGenericSearch

	^queryNodes anySatisfy: [:each | each isGeneric]! !

!OrbeonSummaryApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:02'!
pageFrom
	"The receiver answer the start page to display search results"

	^self pageTo - pageSize + 1! !

!OrbeonSummaryApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:02'!
pageNumber
	^pageNumber! !

!OrbeonSummaryApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:02'!
pageNumber: newValue
	pageNumber := newValue! !

!OrbeonSummaryApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:02'!
pageSize
	^pageSize! !

!OrbeonSummaryApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:02'!
pageSize: newValue
	pageSize := newValue! !

!OrbeonSummaryApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:02'!
pageTo
	"The receiver answer the top limit page to display search results"

	^pageSize * pageNumber! !

!OrbeonSummaryApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:02'!
queryNodes
	^queryNodes! !

!OrbeonSummaryApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:02'!
queryNodes: newValue
	queryNodes := newValue! !

!OrbeonSummaryApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:02'!
queryString
	^queryString! !

!OrbeonSummaryApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:02'!
queryString: newValue
	queryString := newValue! !

!OrbeonSummaryApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:02'!
resultCollection
	^resultCollection! !

!OrbeonSummaryApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:02'!
resultCollection: newValue
	resultCollection := newValue! !

!OrbeonSummaryApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 13:02'!
resultSize

	^resultCollection size! !

!OrbeonSummaryApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:02'!
searchTotal
	^searchTotal! !

!OrbeonSummaryApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:02'!
searchTotal: newValue
	searchTotal := newValue! !

!OrbeonSummaryApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:02'!
searchValues
	^searchValues! !

!OrbeonSummaryApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:02'!
searchValues: newValue
	searchValues := newValue! !

!OrbeonSummaryApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:02'!
total
	^total! !

!OrbeonSummaryApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:02'!
total: newValue
	total := newValue! !

!OrbeonSummaryApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:02'!
user
	^user! !

!OrbeonSummaryApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:02'!
user: newValue
	user := newValue! !

!OrbeonSummaryApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 13:02'!
xmlSearchDefinitionDocument
	^xmlSearchDefinitionDocument! !

!OrbeonSummaryApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 13:02'!
xmlSearchDefinitionDocument: newValue
	xmlSearchDefinitionDocument := newValue! !

!OrbeonServiceOperationApi class methodsFor: 'other' stamp: 'brunobb 02/16/2018 11:44'!
newFor: aWARestfulHandler

	^super new initialize
		restHandler: aWARestfulHandler;
		yourself! !

!OrbeonServiceOperationApi class methodsFor: 'other' stamp: 'brunobb 02/16/2018 12:28'!
newFor: aWARestfulHandler id: id

	^(self newFor: aWARestfulHandler)
		id: id;
		yourself! !

!OrbeonServiceOperationApi class methodsFor: 'other' stamp: 'brunobb 02/16/2018 11:44'!
newFor: aWARestfulHandler withXml: xmlString

	^(self newFor: aWARestfulHandler)
		xmlString: xmlString;
		yourself! !

!OrbeonServiceOperationApi class methodsFor: 'other' stamp: 'brunobb 02/15/2018 14:05'!
newFor: aWARestfulHandler withXml: xmlString id: id

	^(self newFor: aWARestfulHandler withXml: xmlString)
		id: id;
		yourself! !

!OrbeonServiceOperationApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 09:10'!
addDeferredProcessingFor: anOrbeonFormInstance
	"The receiver add the form instance <anOrbeonFormInstance> to be processed later by other gem"

	OrbeonDeferredProcessingQueue default addDeferredInstance: anOrbeonFormInstance! !

!OrbeonServiceOperationApi methodsFor: 'other' stamp: 'brunobb 02/15/2018 13:35'!
apiConfiguration

	^OrbeonApiConfiguration default! !

!OrbeonServiceOperationApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 09:47'!
appName
	^appName! !

!OrbeonServiceOperationApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 09:47'!
appName: newValue
	appName := newValue! !

!OrbeonServiceOperationApi methodsFor: 'other' stamp: 'brunobb 02/16/2018 10:25'!
auditStorage

	^OrbeonAuditStorage default! !

!OrbeonServiceOperationApi methodsFor: 'parse' stamp: 'brunobb 02/15/2018 13:48'!
createFormReader

	formReader := OrbeonXPathFormReader for: xmlString! !

!OrbeonServiceOperationApi methodsFor: 'Accessing' stamp: 'brunobb 02/16/2018 09:47'!
formName
	^formName! !

!OrbeonServiceOperationApi methodsFor: 'Updating' stamp: 'brunobb 02/16/2018 09:47'!
formName: newValue
	formName := newValue! !

!OrbeonServiceOperationApi methodsFor: 'Accessing' stamp: 'brunobb 02/15/2018 13:11'!
formReader
	^formReader! !

!OrbeonServiceOperationApi methodsFor: 'Updating' stamp: 'brunobb 02/15/2018 13:11'!
formReader: newValue
	formReader := newValue! !

!OrbeonServiceOperationApi methodsFor: 'metadata' stamp: 'brunobb 02/16/2018 09:57'!
getApplicationName

	appName ifNil: [appName := formReader getApplicationName].

	^appName! !

!OrbeonServiceOperationApi methodsFor: 'metadata' stamp: 'brunobb 02/15/2018 13:15'!
getDescription

	^formReader getDescription! !

!OrbeonServiceOperationApi methodsFor: 'metadata' stamp: 'brunobb 02/16/2018 09:57'!
getFormName

	formName ifNil: [formName := formReader getFormName].

	^formName! !

!OrbeonServiceOperationApi methodsFor: 'metadata' stamp: 'brunobb 02/15/2018 13:15'!
getTitle

	^formReader getTitle! !

!OrbeonServiceOperationApi methodsFor: 'Accessing' stamp: 'brunobb 02/15/2018 12:44'!
id
	^id! !

!OrbeonServiceOperationApi methodsFor: 'Updating' stamp: 'brunobb 02/15/2018 12:44'!
id: newValue
	id := newValue! !

!OrbeonServiceOperationApi methodsFor: 'parse' stamp: 'brunobb 02/15/2018 13:05'!
parseXmlString

	xmlDocument := XMLDOMParser parse: xmlString.! !

!OrbeonServiceOperationApi methodsFor: 'Accessing' stamp: 'brunobb 02/15/2018 14:00'!
restHandler
	^restHandler! !

!OrbeonServiceOperationApi methodsFor: 'Updating' stamp: 'brunobb 02/15/2018 14:00'!
restHandler: newValue
	restHandler := newValue! !

!OrbeonServiceOperationApi methodsFor: 'other' stamp: 'brunobb 02/17/2018 09:10'!
seasideMimeDocument

	^WAMimeDocument on: 'OK' mimeType: WAMimeType textPlain! !

!OrbeonServiceOperationApi methodsFor: 'exceptions' stamp: 'brunobb 02/16/2018 10:18'!
signalNoApplicationException: app

	^NoApplicationException signal: 'No such application [', app, ']'! !

!OrbeonServiceOperationApi methodsFor: 'exceptions' stamp: 'brunobb 02/16/2018 10:26'!
signalNoFormException

	^NoOrbeonFormException signal: 'No such form [', self getFormName, '] version [', version, '] with id [', id, '] in application [', self getApplicationName, ']'! !

!OrbeonServiceOperationApi methodsFor: 'Accessing' stamp: 'brunobb 02/15/2018 12:44'!
version
	^version! !

!OrbeonServiceOperationApi methodsFor: 'Updating' stamp: 'brunobb 02/15/2018 12:44'!
version: newValue
	version := newValue! !

!OrbeonServiceOperationApi methodsFor: 'Accessing' stamp: 'brunobb 02/15/2018 12:59'!
xmlDocument
	^xmlDocument! !

!OrbeonServiceOperationApi methodsFor: 'Updating' stamp: 'brunobb 02/15/2018 12:59'!
xmlDocument: newValue
	xmlDocument := newValue! !

!OrbeonServiceOperationApi methodsFor: 'other' stamp: 'brunobb 02/22/2018 16:39'!
xmlHeader

	^'<?xml version="1.0" encoding="utf-8"?>'! !

!OrbeonServiceOperationApi methodsFor: 'Accessing' stamp: 'brunobb 02/15/2018 11:11'!
xmlString
	^xmlString! !

!OrbeonServiceOperationApi methodsFor: 'Updating' stamp: 'brunobb 02/15/2018 11:11'!
xmlString: newValue
	xmlString := newValue! !

BaselineOf subclass: #BaselineOfOrbeonPersistenceApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

WARestfulHandler subclass: #WAOrbeonPersistenceLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi'!

!WAOrbeonPersistenceLayer class methodsFor: 'other' stamp: 'BrunoBB 02/08/2017 06:11'!
register
	| application |

	WAAdmin unregister: 'orbeon-gemstone-api'.

	application := WAAdmin register: self at: 'orbeon-gemstone-api'.! !

!WAOrbeonPersistenceLayer class methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 10:52'!
unregister

	WAAdmin unregister: 'orbeon-gemstone-api'.! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 14:01'!
apiConfiguration

	^OrbeonApiConfiguration default! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/21/2015 11:09'!
auditStorage

	^OrbeonAuditStorage default! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 03/16/2017 10:52'!
defaultDefinitionAnswer: formName app: app
	"This method is called when the OrbeonApplication was not found. This can be caused by Orbeon calling library forms"

	self requestContext response headerAt: 'orbeon-form-definition-version' put: '1'.

	^(GRCodec forEncoding: 'utf-8') decode: (OrbeonPublishedFormDefinition defaultXmlDefinition: formName app: app)! !

!WAOrbeonPersistenceLayer methodsFor: 'service-delete' stamp: 'brunobb 02/18/2018 11:37'!
deleteFormDefinitionWithId: id
	"This method is called by Orbeon when a user click 'Delete' in a Form Definition in the Form Runner page"
	<delete>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>

	^(OrbeonFormDefinitionDeleteApi newFor: self id: id) doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-delete' stamp: 'brunobb 02/16/2018 12:33'!
deleteFormDraft: formName app: app withId: id
	"This method is called by Orbeon when a user click 'Delete' in a Form Instance Draft in the Form Runner page"
	| apiOperation |
	<delete>
	<path: '/crud/{2}/{1}/draft/{3}/data.xml'>

	apiOperation := OrbeonFormDraftDeleteApi newFor: self id: id.
	apiOperation appName: app;
		formName: formName.

	apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-delete' stamp: 'brunobb 02/16/2018 12:34'!
deleteFormInstance: formName app: app withId: id
	"This method is called by Orbeon when a user click 'Delete' in a Form Instance in the Form Runner page"
	| apiOperation |
	<delete>
	<path: '/crud/{2}/{1}/data/{3}/data.xml'>

	apiOperation := OrbeonFormInstanceDeleteApi newFor: self id: id.
	apiOperation appName: app;
		formName: formName.

	apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'brunobb 02/18/2018 10:57'!
duplicateFormDefinitionNewId: id
	"This service duplicate the <OrbeonPublishedFormDefinition> contained in the request body with the new id <id>"
	| apiOperation |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>

	apiOperation := OrbeonFormDefinitionDuplicateApi newFor: self withXml: self requestContext request rawBody id: id.

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'brunobb 02/19/2018 13:59'!
duplicateFormInstance: formName app: app newId: id
	"This method is called by Orbeon when a user click 'Duplicate' in a Form Instance in the Form Runner"
	| apiOperation versionNumber |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/data/{3}/data.xml'>

	versionNumber := (self requestContext request headerAt: 'orbeon-form-definition-version') ifNil: [1] ifNotNil: [:value | Number fromString: value].
 
	apiOperation := OrbeonFormInstanceDuplicateApi newFor: self withXml: self requestContext request rawBody id: id.
	apiOperation appName: app;
		formName: formName;
		version: versionNumber.

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/19/2018 13:30'!
getAllFormDefinitionVesionsFor: formName app: app allversions: aStringBoolean
	"Implemented as stated in: 
	https://doc.orbeon.com/form-runner/api/persistence/forms-metadata.html#returning-all-form-definition-versions"
	| apiOperation |
	<get>
	<produces: 'application/xml'>
	<path: '/form/{2}/{1}?all-versions={3}'>

	apiOperation := OrbeonAllFormDefinitionVersionsApi newFor: self.
	apiOperation appName: app;
		formName: formName;
		allversions: aStringBoolean.

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/21/2018 13:23'!
getDefinitionForFormInstanceWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page (or go directly to edit/view page of a form). The Summary then open the Form Instance in it's corresponding form definition.
	This service is used in combination of #getXmlOfFormInstanceWithId:form:app: to <get> the actual data of the form"
	| apiOperation |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/form/form.xhtml?document={1}'>

	apiOperation := OrbeonDefinitionForFormInstanceApi newFor: self id: id.
	apiOperation appName: app;
		formName: form.

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/21/2018 11:14'!
getFormDefinitionWithId: id dataFormat: dataFormatVersion
	"This service is called when a click is performed on the Orbeon Form Builder Summary page.
	The Summary then should open the Orbeon Builder with the code of the clicked form."
	<get>
	<produces: 'application/xml'>
	<path: '/crud/orbeon/builder/data/{1}/data.xml?data-format-version={2}'>

	^(OrbeonFormDefinitionSourceApi newFor: self id: id) doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/22/2018 16:34'!
getFormVersion: formName app: app 
	"This method is called by Orbeon when a Form Definition (inside the Builder) is about to be Published.
	This method answer the latest version of the form definition <formName> in application <app>.
	Using the header <orbeon-form-definition-version> to set the version number.
	It also called when a new Form Instance page is about to be displayed (app/form/new)"
	| apiOperation |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/form/form.xhtml'>

	apiOperation := OrbeonLastFormDefinitionSourceApi newFor: self.
	apiOperation appName: app;
		formName: formName;
		headerVersionValue: (self requestContext request headerAt: 'orbeon-form-definition-version').

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/16/2018 12:57'!
getOrbeonFr
	"This service is called when accessing Form Runner Home: ../orbeon/fr/ "
	<get>
	<produces: 'application/xml'>
	<path: '/form'>

	^(OrbeonFrPageApi newFor: self) doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/16/2018 12:47'!
getToolboxForApplication: appName
	"This method is called by Orbeon when the Form Builder is about to be Opened.
	It show the available -Library- forms for the application named <appName> "
	| apiOperation |
	<get>
	<produces: 'application/xml'>
	<path: '/custom/{1}/builder/toolbox'>

	apiOperation := OrbeonGetToolboxApi newFor: self.
	apiOperation appName: appName;
		headerValue: (self requestContext request headerAt: 'orbeon-form-definition-version').

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/17/2018 07:32'!
getXmlOfFormDraftWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page.
	The Summary then should open the Form Instance (view/edit mode ) in the corresponding form definition (template).
	This sevice is used in combination with #getDefinitionForFormInstanceWithId:form:app: that <get> the form definition (template) to the form with id <id>"
	| apiOperation |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/draft/{1}/data.xml'>

	apiOperation := OrbeonFormDraftSourceApi newFor: self id: id.
	apiOperation appName: app;
		formName: form;
		group: (self requestContext request headerAt: 'orbeon-group');
		username: (self requestContext request headerAt: 'orbeon-username').

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/26/2018 11:01'!
getXmlOfFormDraftWithId: id form: form app: app dataFormat: dataFormatVersion
	"This service is called when a click is performed on the Orbeon Form Summary page.
	The Summary then should open the Form Instance (view/edit mode ) in the corresponding form definition (template).
	This sevice is used in combination with #getDefinitionForFormInstanceWithId:form:app: that <get> the form definition (template) to the form with id <id>"
	| apiOperation |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/draft/{1}/data.xml?data-format-version={4}'>

	apiOperation := OrbeonFormDraftSourceApi newFor: self id: id.
	apiOperation appName: app;
		formName: form;
		group: (self requestContext request headerAt: 'orbeon-group');
		username: (self requestContext request headerAt: 'orbeon-username').

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/17/2018 07:35'!
getXmlOfFormInstanceWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page.
	The Summary then should open the Form Instance (view/edit mode) in the corresponding form definition (template).
	This sevice is used in combination with #getDefinitionForFormInstanceWithId:form:app: that <get> the form definition (template) to the form with id <id>"
	| apiOperation |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/data/{1}/data.xml'>

	apiOperation := OrbeonFormInstanceSourceApi newFor: self id: id.
	apiOperation appName: app;
		formName: form;
		group: (self requestContext request headerAt: 'orbeon-group');
		username: (self requestContext request headerAt: 'orbeon-username').

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/26/2018 11:01'!
getXmlOfFormInstanceWithId: id form: form app: app dataFormat: dataFormatVersion
	"This service is called when a click is performed on the Orbeon Form Summary page.
	The Summary then should open the Form Instance (view/edit mode) in the corresponding form definition (template).
	This sevice is used in combination with #getDefinitionForFormInstanceWithId:form:app: that <get> the form definition (template) to the form with id <id>"
	| apiOperation |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/data/{1}/data.xml?data-format-version={4}'>

	apiOperation := OrbeonFormInstanceSourceApi newFor: self id: id.
	apiOperation appName: app;
		formName: form;
		group: (self requestContext request headerAt: 'orbeon-group');
		username: (self requestContext request headerAt: 'orbeon-username').

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'delete this' stamp: 'brunobb 02/26/2018 09:52'!
handle: aRequestContext
	"Handle a request described by aRequestContext. Do not override this method; instead subclass #handleFiltered: to allow filters to process the request first."

	"self halt."

	aRequestContext push: self during: [ self filter handleFiltered: aRequestContext ]! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'brunobb 02/18/2018 11:23'!
publishFormDefinition: formName app: app withId: documentId
	"This method is called by Orbeon when a Form Definition has been published with form name <formName> in application <app> with form id <documentId>"
	| apiOperation |
	<put>
	<consumes: 'application/xml'>
	<path: '/crud/{2}/{1}/form/form.xhtml?document={3}'>

	apiOperation := OrbeonFormBuilderPublishApi newFor: self withXml: self requestContext request rawBody id: documentId.
	apiOperation createFormReader;
		appName: app;
		formName: formName;
		headerVersion: (self requestContext request headerAt: 'orbeon-form-definition-version').

	^apiOperation doIt.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'brunobb 02/17/2018 08:34'!
receiveAndPublishFileFor: formName app: app documentId: documentId fileId: fileId
	"This service is called when a user click -Publish- form in Orbeon Form Builder and the form definition has attached files.
	The Form Definition is <formName> in the Orbeon Application <app> where the id of the form definition is <documentId> and the attached file id is <fileId>.
	This service is called for each attached files in the Form Definition. 
	The attached file is stored in the repository"
	| apiOperation |
	<put>
	<path: '/crud/{2}/{1}/form/{4}?document={3}'>

	apiOperation := OrbeonReceiveAndPublishFileApi newFor: self id: documentId.
	apiOperation fileId: fileId;
		fileContents: self requestContext request rawBody;
		appName: app;
		formName: formName.

	apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'brunobb 02/17/2018 08:34'!
receiveAndSaveFileForDefinitionWithId: definitionId fileId: fileId valid: aBoolean
	"This service receives a file with id <fileId> from Orbeon Form Builder when the a user clicked -Save-.
	The file was uploaded into a Form Definition as a Custom PDF or as direct file Upload.
	A direct file upload is when a File Attachment is added to a Form Definition and a concrete file is also uploaded"
	| apiOperation |
	<put>
	<path: '/crud/orbeon/builder/data/{1}/{2}.bin?valid={3}'>

	apiOperation := OrbeonReceiveAndSaveDefinitionFileApi newFor: self id: definitionId.
	apiOperation fileId: fileId;
		fileContents: self requestContext request rawBody.
		
	apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'brunobb 02/17/2018 08:43'!
receiveAndSaveFileForDraft: formName app: app draftId: draftId fileId: fileId valid: aBoolean
	"This service is called from Orbeon Form Runner -new/edit- when a file is uploaded (and autosave is -true-) to a Form Instance.
	When the form is autosaved then all form's attachments are sent to this service "
	| apiOperation |
	<put>
	<path: '/crud/{2}/{1}/draft/{3}/{4}?valid={5}'>

	apiOperation := OrbeonReceiveAndSaveDraftFileApi newFor: self id: draftId.
	apiOperation fileId: fileId;
		fileContents: self requestContext request rawBody;
		appName: app;
		formName: formName.

	apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'brunobb 02/17/2018 08:51'!
receiveAndSaveFileForInstance: formName app: app instanceId: instanceId fileId: fileId valid: aBoolean
	"This service is called from Orbeon Form Runner -new/edit- when a file is uploaded to a Form Instance.
	When the form is sent then all form's attachments are sent to this service"
	| apiOperation |
	<put>
	<path: '/crud/{2}/{1}/data/{3}/{4}?valid={5}'>

	apiOperation := OrbeonReceiveAndSaveInstanceFileApi newFor: self id: instanceId.
	apiOperation fileId: fileId;
		fileContents: self requestContext request rawBody;
		appName: app;
		formName: formName.

	apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'brunobb 02/16/2018 12:05'!
saveDraftFormInstance: formName app: app withId: id valid: aBoolean
	"This method is called by Orbeon when a Form is autosaved in a Form Instance page"
	| apiOperation |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/draft/{3}/data.xml?valid={4}'>

	apiOperation := OrbeonFormSaveDraftApi newFor: self withXml: self requestContext request rawBody id: id.
	apiOperation appName: app;
		formName: formName;
		isValid: aBoolean;
		version: (Number fromString: (self requestContext request headerAt: 'orbeon-form-definition-version'));
		username:  (self requestContext request headerAt: 'orbeon-username'); "BUG - creator set only one time"
		modifiedUser: (self requestContext request headerAt: 'orbeon-username');
		groupname: (self requestContext request headerAt: 'orbeon-group').

	apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'brunobb 02/26/2018 10:51'!
saveFinalFormInstance: formName app: app withId: id dataFormat: dataFormatVersion valid: aBoolean
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| apiOperation version |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/data/{3}/data.xml?data-format-version={4}&valid={5}'>

	version := ([Number fromString: (self requestContext request headerAt: 'orbeon-form-definition-version')] on: Error do: [:ex | nil]) ifNil: [1] ifNotNil: [:value | value].

	apiOperation := OrbeonFormSaveFinalApi newFor: self withXml: self requestContext request rawBody id: id.
	apiOperation appName: app;
		formName: formName;
		isValid: aBoolean;
		version: version;
		username:  (self requestContext request headerAt: 'orbeon-username'); "BUG - creator set only one time"
		modifiedUser: (self requestContext request headerAt: 'orbeon-username');
		groupname: (self requestContext request headerAt: 'orbeon-group').

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'brunobb 02/21/2018 10:34'!
saveInFormBuilderDefinitionWithId: id dataFormat: dataFormatVersion valid: stringBool
	"This service is called by Orbeon when a user click on -Save- inside the Form Builder.
	A Form Definition has been saved "
	| apiOperation |
	<put>
	<path: '/crud/orbeon/builder/data/{1}/data.xml?data-format-version={2}&valid={3}'>

	(Boolean fromString: stringBool) 
	ifTrue: [ apiOperation := OrbeonFormBuilderSaveApi newFor: self withXml: self requestContext request rawBody id: id.

				apiOperation createFormReader.

				^apiOperation doIt]! !

!WAOrbeonPersistenceLayer methodsFor: 'service-post' stamp: 'brunobb 02/21/2018 10:00'!
searchInFormBuilderSummary
	"This service is called by Orbeon when rendering an Orbeon Form Builder Summary page and
	answer a well formatted XML with the result of the query received in the request.
	This XML is going to be displayed in the Orbeon Form Builder Summary page"	
	| searchApi |
	<post>
	<produces: 'application/xml'>
	<path: '/search/orbeon/builder'>

	searchApi := OrbeonDefinitionSearchApi new.
	searchApi xmlSearchDefinitionDocument: (XMLDOMParser parse: self requestContext request rawBody).
	searchApi getPageSize;
				getPageNumber;
				group: (self requestContext request headerAt: 'orbeon-group');
				user: (self requestContext request headerAt: 'orbeon-username').

	searchApi doIt. 

	^searchApi generateXmlAnswerForBuilderSummary! !

!WAOrbeonPersistenceLayer methodsFor: 'service-post' stamp: 'brunobb 02/26/2018 09:49'!
searchInFormSummary: formName app: app
	"This service is called in two different situations:
	1- When rendering an Orbeon Form Summary page and answer a well formatted XML with the result of the query received in the request. This XML is going to be displayed in the Orbeon Form Summary page
	2- When a form instance is going to be rendered is called to find out if a form instance with certain <id> has a draft to be displayed"
	| application definition searchApi |
	<post>
	<produces: 'application/xml'>
	<path: '/search/{2}/{1}'>

	application := self getOrbeonApplicationClass applicationNamed: app ifNone: [^self noRouteFound: self requestContext "^self signalNoApplicationException: app"].
	definition := application definitionNamed: formName ifNone: [^self noRouteFound: self requestContext "^self signalNoFormException: formName app: app"].

	(definition isDeleted or:[definition isAvailable not]) ifTrue: [^self noRouteFound: self requestContext].
	definition isDeleted ifTrue: [^self noRouteFound: self requestContext].

	searchApi := OrbeonInstanceSearchApi for: application formName: formName.

	searchApi xmlSearchDefinitionDocument: (XMLDOMParser parse: self requestContext request rawBody);
					createQueryNodes;
					getPageSize;
					getPageNumber;
					group: (self requestContext request headerAt: 'orbeon-group');
					user: (self requestContext request headerAt: 'orbeon-username').

	searchApi doIt.

	^searchApi generateXmlAnswer! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/17/2018 09:54'!
sendFileForCustomPDF: formName app: app fileId: fileId
	"This service is called when Orbeon requires a Custom PDF of a form or the Form Instance has any attachments and the user has clicked -Send-"
	| apiOperation |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/{2}/{1}/form/{3}'>

	apiOperation := OrbeonSendCustomPdfFileApi newFor: self.
	apiOperation fileId: fileId;
		appName: app;
		formName: formName.

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/17/2018 09:38'!
sendFileForDefinitionWithId: definitionId fileId: fileId
	"This service is called by Orbeon Form Builder to get/obtain the attached file with id <fileId> for the Form Definition <definitionId>.
	The service answer an octet stream to the caller."
	| apiOperation |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/orbeon/builder/data/{1}/{2}'>

	apiOperation := OrbeonSendFormDefinitionFileApi newFor: self id: definitionId.
	apiOperation fileId: fileId.

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/17/2018 09:44'!
sendFileForDraft: formName app: app draftId: draftId fileId: fileId
	"This service is called when rendering the Draft of the form in Form Instance page"
	| apiOperation |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/{2}/{1}/draft/{3}/{4}'>

	apiOperation := OrbeonSendFormDraftFileApi newFor: self id: draftId.
	apiOperation fileId: fileId;
		appName: app;
		formName: formName.

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'brunobb 02/17/2018 09:48'!
sendFileForInstance: formName app: app instanceId: instanceId fileId: fileId
	"This service is called when rendering the form Instance in Form Instance page"
	| apiOperation |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/{2}/{1}/data/{3}/{4}'>

	apiOperation := OrbeonSendFormInstanceFileApi newFor: self id: instanceId.
	apiOperation fileId: fileId;
		appName: app;
		formName: formName.

	^apiOperation doIt! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'brunobb 02/23/2018 18:24'!
unpublishFormDefinition: formName app: app
	"This method is called by Orbeon when a Form Definition has been unpublished with form name <formName> in application <app>"
	| apiOperation |
	<put>
	<path: '/crud/{2}/{1}/form/form.xhtml'>

	apiOperation := OrbeonFormBuilderUnpublishApi newFor: self.
	apiOperation appName: app;
		formName: formName.

	^apiOperation doIt! !
OrbeonApiConfiguration initialize!
OrbeonAuditStorage initialize!
OrbeonDeferredProcessingQueue initialize!
